//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//
//                               d/s
//        * * *| * * * * * * * *| * * * * * * * *| * * *
//   bit     -9 -8-7-6-5-4-3-2-1  0 1 2 3 4 5 6 7  8
//                         *
//   n                     |-> n plus
//               n minus <-|
//
//---------------------------------------------------------------------------
void bitcpy(unsigned char *d, int dBit, unsigned char *s, int sBit, int n)
{
    unsigned char *pd, *ps, vd, vs, md, ms;
    int           bd, bs, i;

    ajustBitPos(d, dBit, &pd, &bd);
    ajustBitPos(s, sBit, &ps, &bs);
    vd = *pd;
    vs = *ps;
    md = (unsigned char)(1 << bd);
    ms = (unsigned char)(1 << bs);
    for (i = 0; i < abs(n); i++) {
        if (vs & ms)  vd |= md;
        else          vd &= (unsigned char)~md;
        if (n > 0) {
            bd--;
            md >>= 1;
            if (bd < 0) {
                *pd = vd;
                vd = *(++pd);
                bd = 7;
                md = (unsigned char)0x80;
            }
            bs--;
            ms >>= 1;
            if (bs < 0) {
                vs = *(++ps);
                bs = 7;
                ms = (unsigned char)0x80;
            }
        }
        else {
            bd++;
            md <<= 1;
            if (bd > 7) {
                *pd = vd;
                vd = *(--pd);
                bd = 0;
                md = (unsigned char)1;
            }
            bs++;
            ms <<= 1;
            if (bs > 7) {
                vs = *(--ps);
                bs = 0;
                ms = (unsigned char)1;
            }
        }
    }
    if (((n > 0) && (bd != 7)) || ((n < 0) && bd))  *pd = vd;
}
//---------------------------------------------------------------------------
bool bitcmp(unsigned char *d, int dBit, unsigned char *s, int sBit, int n, int *sameN, int *revrN)
{
    unsigned char *pd, *ps, vd, vs, md, ms;
    int           bd, bs, i, td, ts, flag = 0;

    *sameN = 0;
    *revrN = 0;
    ajustBitPos(d, dBit, &pd, &bd);
    ajustBitPos(s, sBit, &ps, &bs);
    vd = *pd;
    vs = *ps;
    md = (unsigned char)(1 << bd);
    ms = (unsigned char)(1 << bs);
    for (i = 0; i < abs(n); i++) {
        if (vs & ms)  ts = 1;
        else          ts = 0;
        if (vd & md)  td = 1;
        else          td = 0;
        if (ts != td) {
            (*revrN)++;
            flag = 1;
        }
        else {
            if (flag == 0)  (*sameN)++;
        }
        if (n > 0) {
            bd--;
            md >>= 1;
            if (bd < 0) {
                vd = *(++pd);
                bd = 7;
                md = (unsigned char)0x80;
            }
            bs--;
            ms >>= 1;
            if (bs < 0) {
                vs = *(++ps);
                bs = 7;
                ms = (unsigned char)0x80;
            }
        }
        else {
            bd++;
            md <<= 1;
            if (bd > 7) {
                vd = *(--pd);
                bd = 0;
                md = (unsigned char)1;
            }
            bs++;
            ms <<= 1;
            if (bs > 7) {
                vs = *(--ps);
                bs = 0;
                ms = (unsigned char)1;
            }
        }
    }
    if (*sameN == abs(n))  return true;
    else                   return false;
}
//---------------------------------------------------------------------------
bool isbit(unsigned char *s, int sBit)
{
    unsigned char *ps;
    int           bs;

    ajustBitPos(s, sBit, &ps, &bs);
    if (*ps & (unsigned char)(1 << bs))  return true;
    else                                 return false;
}
//---------------------------------------------------------------------------
void bitset(unsigned char *s, int sBit, int offOn)
{
    unsigned char *ps;
    int           bs;

    ajustBitPos(s, sBit, &ps, &bs);
    if (offOn)  *ps |= (unsigned char)(1 << bs);
    else        *ps &= (unsigned char)~(1 << bs);
}
//---------------------------------------------------------------------------
void ajustBitPos(unsigned char *s, int sBit, unsigned char **a, int *aBit)
{
    div_t ss;

    ss = divide(sBit, 8);
    *a = s + ss.quot;
    *aBit = 7 - ss.rem;
}
//---------------------------------------------------------------------------
div_t divide(int num, int denom)
{
    div_t x;

    x.quot = num / denom;
    x.rem  = num % denom;
    if (x.rem < 0) {
        x.quot--;
        x.rem += denom;
    }
    return x;
}
//---------------------------------------------------------------------------
bool hexaToBit(unsigned char *bitValue, char *hexa)
{
    int           n, m, f;
    char          *p;
    unsigned char val, v, *q;

    n = strlen(hexa);
    p = hexa + n - 1;
    m = n / 2;
    if (n % 2)  m++;
    q = bitValue + m - 1;
    val = 0;
    f   = 0;
    while (n) {
        if ((*p >= '0') && (*p <= '9'))       v = (unsigned char)(*p - '0');
        else if ((*p >= 'a') && (*p <= 'f'))  v = (unsigned char)(*p - 'a' + 0xA);
        else if ((*p >= 'A') && (*p <= 'F'))  v = (unsigned char)(*p - 'A' + 0xA);
        else break;
        if (f == 0) {
            val = v;
            f = 1;
        }
        else {
            v <<= 4;
            *(q--) = val | v;
            val = 0;
            f   = 0;
        }
        p--;
        n--;
    }
    if (f)  *q = val;
    if (n)  return false;
    else    return true;
}
//---------------------------------------------------------------------------
int rightAlign(int bits)
{
    return ((bits / 8 + ((bits % 8) ? 1 : 0)) * 8 - 1);
}
//---------------------------------------------------------------------------

