//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "EditColor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void setLPal(LogPalette &lPal, char *mapFile)
{
    FILE *fp;
    char buf[128];
    int  mapC[3];
    int  i, j;

    lPal.pal.palVersion    = 0x300;
    lPal.pal.palNumEntries = COLORS;
    fp = fopen(mapFile, "rt");
    if (fp == NULL)  ShowMessage("Color map not found");
    for (i = 0; i < COLORS; i++) {
        if (fp) {
            fgets(buf, 128, fp);
            if (i) {
                sscanf(buf, "%d%d%d", &mapC[0], &mapC[1], &mapC[2]);
                for (j = 0; j < 3; mapC[j++] &= 0xff);
            }
            else  for (j = 0; j < 3; mapC[j++] = 0);
        }
        else  for (j = 0; j < 3; mapC[j++] = 0);
        lPal.pal.palPalEntry[i].peRed   = (BYTE)mapC[0];
        lPal.pal.palPalEntry[i].peGreen = (BYTE)mapC[1];
        lPal.pal.palPalEntry[i].peBlue  = (BYTE)mapC[2];
        lPal.pal.palPalEntry[i].peFlags = 0;
    }
    if (fp)  fclose(fp);
}
//---------------------------------------------------------------------------
void saveLPal(LogPalette &lPal, char *mapFile)
{
    FILE *fp;
    char buf[128];
    int  mapC[3];
    int  i;

    fp = fopen(mapFile, "wt");
    if (fp == NULL)  {
        ShowMessage("Can't write Color map");
        return;
    }
    for (i = 0; i < COLORS; i++) {
        mapC[0] = (int)lPal.pal.palPalEntry[i].peRed;
        mapC[1] = (int)lPal.pal.palPalEntry[i].peGreen;
        mapC[2] = (int)lPal.pal.palPalEntry[i].peBlue;
        sprintf(buf, "%d %d %d\n", mapC[0], mapC[1], mapC[2]);
        fputs(buf, fp);
    }
    fclose(fp);
}
//---------------------------------------------------------------------------
void editColorFormInitialize()
{
    int i;

    img.leftAnchor  = 0;
    img.rightAnchor = 255;
    img.changePoint = 128;
    img.leftColor[0] = (int)par.lPal.pal.palPalEntry[img.leftAnchor].peRed;
    img.leftColor[1] = (int)par.lPal.pal.palPalEntry[img.leftAnchor].peGreen;
    img.leftColor[2] = (int)par.lPal.pal.palPalEntry[img.leftAnchor].peBlue;
    img.rightColor[0] = (int)par.lPal.pal.palPalEntry[img.rightAnchor].peRed;
    img.rightColor[1] = (int)par.lPal.pal.palPalEntry[img.rightAnchor].peGreen;
    img.rightColor[2] = (int)par.lPal.pal.palPalEntry[img.rightAnchor].peBlue;
    img.changeColor[0] = (int)par.lPal.pal.palPalEntry[img.changePoint].peRed;
    img.changeColor[1] = (int)par.lPal.pal.palPalEntry[img.changePoint].peGreen;
    img.changeColor[2] = (int)par.lPal.pal.palPalEntry[img.changePoint].peBlue;
    for (i = 0;i < 3;i++) {
        img.leftGradient[i] = 0;
        img.rightGradient[i] = 0;
    }
    EditColorForm->LeftAnchorScrollBar->Position  = img.leftAnchor;
    EditColorForm->RightAnchorScrollBar->Position = img.rightAnchor;
    EditColorForm->ChangePointScrollBar->Position = img.changePoint;
    EditColorForm->AjustVerticalScroll();
    EditColorForm->ShowAll();
}
//---------------------------------------------------------------------------
void changeRGB()
{
    int  i;
    BYTE rgb[3];

    img.changeRGBIndex++;
    if (img.changeRGBIndex == 6)  img.changeRGBIndex = 0;
    for (i = 0; i < COLORS; i++) {
        rgb[0] = par.lPal.pal.palPalEntry[i].peRed;
        rgb[1] = par.lPal.pal.palPalEntry[i].peGreen;
        rgb[2] = par.lPal.pal.palPalEntry[i].peBlue;
        if (img.changeRGBIndex % 3) {
            par.lPal.pal.palPalEntry[i].peRed   = rgb[2];
            par.lPal.pal.palPalEntry[i].peGreen = rgb[0];
            par.lPal.pal.palPalEntry[i].peBlue  = rgb[1];
        }
        else {
            par.lPal.pal.palPalEntry[i].peRed   = rgb[1];
            par.lPal.pal.palPalEntry[i].peGreen = rgb[0];
        }
    }
}
//---------------------------------------------------------------------------
void colorCycling(int cycle)
{
    LogPalette lp;
    int        i, j;

    lp = par.lPal;
    if (img.cyclingReverse == 0)  j = cycle;
    else                          j = COLORS - 1 - cycle;
    for (i = 0; i < COLORS - 1; i++) {
        par.lPal.entry[i] = lp.entry[j];
        j++;
        if (j >= COLORS - 1)  j = 0;
    }
}
//---------------------------------------------------------------------------
void changePalette()
{
    int  i, j;
    BYTE *ptr;
    char *save, *p;

    save = new char[img.fractalBitmap->Height * img.fractalBitmap->Width];
    for (p = save, i = 0; i < img.fractalBitmap->Height; i++) {
        ptr = (BYTE *)img.fractalBitmap->ScanLine[i];
        for (j = 0; j < img.fractalBitmap->Width; *(p++) = *(ptr++), j++);
    }
    img.fractalBitmap->Palette = CreatePalette(&par.lPal.pal);
    for (p = save, i = 0; i < img.fractalBitmap->Height; i++) {
        ptr = (BYTE *)img.fractalBitmap->ScanLine[i];
        for (j = 0; j < img.fractalBitmap->Width; *(ptr++) = *(p++), j++);
    }
    delete [] save;
}
//---------------------------------------------------------------------------
void startCyclingAuto()
{
    ControlForm->StartButton->Caption = "Stop";
    img.onDrawing       = ColorCycling;
    img.threadTempStop  = 0;
    img.threadTerminate = 0;
    img.threads         = new TThreads(false);
}
//---------------------------------------------------------------------------
void cyclingInThread()
{
    while (1) {
        SendMessage(ImageForm->Handle, WM_CYCLING_PAINT, 0, 0);
        Sleep(50);
        while (img.threadTempStop) {
            img.onTempStop = 1;
            Sleep(50);
        }
        if (img.threadTerminate) {
            calculationStopped();
            img.cyclingTimes = -1;
            return;
        }
        if (img.cyclingTimes > 0) {
            img.cyclingTimes--;
            if (img.cyclingTimes == 0) {
                img.cyclingTimes = -1;
                SendMessage(ImageForm->Handle, WM_FRACTAL_CALC_END, 0, 0);
                return;
            }
        }
    }
}
//---------------------------------------------------------------------------
void cyclingPaint()
{
    colorCycling(1);
    changePalette();
    ImageForm->Image->Picture->Graphic = img.fractalBitmap;
}
//---------------------------------------------------------------------------

