//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "FindingRoot.h"
#include "ReverseAnalysis.h"
#include "ImageSize.h"
#include "Zoom.h"
#include "ZoomInMovie.h"
#include "SelfSimilarityMovie.h"
#include "MovieControl.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TControlForm *ControlForm;
//---------------------------------------------------------------------------
__fastcall TControlForm::TControlForm(TComponent* Owner)
    : TForm(Owner)
{
    Top =  4;
    Left = 8;
    if (Screen->Width <= 1000)  BorderStyle = bsSizeable;
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::StartButtonClick(TObject *Sender)
{
    if (ZoomInMovieForm->StartButton->Enabled == true) {
        ZoomInMovieForm->StartButtonClick(this);
        return;
    }
    if (SelfSimilarityMovieForm->StartButton->Enabled == true) {
        SelfSimilarityMovieForm->StartButtonClick(this);
        return;
    }
    if (img.onDrawing == Non) {
        if (img.zoomInPowerOnEdit)  FindingRootForm->SetZoomInPower();
        if (img.maxRetryOnEdit)     FindingRootForm->SetMaxRetry();
        img.rootFindRetryN = 0;
        rootImageCalculationStart();
    }
    else  img.threadTerminate = 1;
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::ResetButtonClick(TObject *Sender)
{
    resetAndShow();
    img.firstImage = 0;
    showCenterPosition(par.pCenter);
    fractalCalculationStart();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::DimensionEditExit(TObject *Sender)
{
    SetDimension();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::DimensionEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetDimension();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::NthRootEditExit(TObject *Sender)
{
    SetNthRoot();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::NthRootEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetNthRoot();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::PeriodicBitsNumberEditExit(
      TObject *Sender)
{
    SetPeriodicBitsNumber();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::PeriodicBitsNumberEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetPeriodicBitsNumber();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::PeriodicBitsValueEditExit(
      TObject *Sender)
{
    SetPeriodicBitsValue();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::PeriodicBitsValueEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetPeriodicBitsValue();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::TopBitsNumberEditExit(TObject *Sender)
{
    SetTopBitsNumber();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::TopBitsNumberEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetTopBitsNumber();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::TopBitsValueEditExit(TObject *Sender)
{
    SetTopBitsValue();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::TopBitsValueEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetTopBitsValue();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::LastBitsNumberEditExit(
      TObject *Sender)
{
    SetLastBitsNumber();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::LastBitsNumberEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetLastBitsNumber();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::LastBitsValueEditExit(TObject *Sender)
{
    SetLastBitsValue();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::LastBitsValueEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetLastBitsValue();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::AtRandomCheckBoxClick(TObject *Sender)
{
    SetAtRandom();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::ModifyBitsRadioButtonClick(
      TObject *Sender)
{
    SetAtRandomKind(0);
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::FullRandomRadioButtonClick(
      TObject *Sender)
{
    SetAtRandomKind(1);
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::ModifyBitsEditExit(TObject *Sender)
{
    SetModifyBits();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::ModifyBitsEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetModifyBits();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::FindingRootButtonClick(TObject *Sender)
{
    FindingRootForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RXEditExit(TObject *Sender)
{
    SetCenterX();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RXEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetCenterX();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RYEditExit(TObject *Sender)
{
    SetCenterY();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RYEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetCenterY();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::SXEditExit(TObject *Sender)
{
    SetSpanX();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::SXEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetSpanX();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::SYEditExit(TObject *Sender)
{
    SetSpanY();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::SYEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetSpanY();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::MandelbrotRadioButtonClick(TObject *Sender)
{
    img.threadTerminate = 1;
    par.formula = Mandelbrot;
    img.firstImage = 1;
    FractalChanged();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::JuliaRadioButtonClick(TObject *Sender)
{
    img.threadTerminate = 1;
    par.formula = Julia;
    img.firstImage = 1;
    FractalChanged();
    if (par.pSpan[X]) {
        img.returnToMand = 1;
        img.returnToMandPSpan[X] = par.pSpan[X];
        img.returnToMandPSpan[Y] = par.pSpan[Y];
    }
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::MaxIterEditExit(TObject *Sender)
{
    SetMaxIter();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::MaxIterEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetMaxIter();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::MaxIterAutoCheckBoxClick(TObject *Sender)
{
    SetMaxIterAuto();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RotationAngleEditExit(TObject *Sender)
{
    SetRotationAngle();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RotationAngleEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetRotationAngle();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::SaveImageCheckBoxClick(TObject *Sender)
{
    SetSaveImage();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::BMPRadioButtonClick(TObject *Sender)
{
    SetSaveImageExt(0);
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::JPGRadioButtonClick(TObject *Sender)
{
    SetSaveImageExt(1);
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RootOnPaintMessage(TMessage &Message)
{
    rootImageShow(Message.WParam);
}
//---------------------------------------------------------------------------
void __fastcall TControlForm::RootCalcEndMessage(TMessage &Message)
{
    rootImageCalculationEnd();
}
//---------------------------------------------------------------------------
void TControlForm::SetDimension()
{
    int dimension;

    StatusClear();
    try {
        dimension = StrToInt(DimensionEdit->Text);
        if (dimension < 0) {
            StatusAlarm("Invalid number specified");
            dimension = 0;
        }
        if (dimension < (par.topBitsNumber + par.lastBitsNumber)) {
            StatusAlarm("Dimension < Top+Last bits");
            dimension = par.topBitsNumber + par.lastBitsNumber;
        }
        if (dimension > MAX_DIMENSION) {
            StatusAlarm("Dimension Limit.");
            dimension = MAX_DIMENSION;
        }
        if (par.dimension != dimension) {
            RootChanged();
            par.dimension = dimension;
            BitsToNthRoot();
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowDimension();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetNthRoot()
{
    char hexa[MAX_DIMENSION/4+2];

    strncpy(hexa, NthRootEdit->Text.c_str(), MAX_DIMENSION/4);
    hexa[MAX_DIMENSION/4] = 0;
    HexaToBits(par.dimension, par.nthRoot, hexa);
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetPeriodicBitsNumber()
{
    int periodicBitsNumber;
    unsigned char mask[8] = { 0xff, 0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3f, 0x7f };

    StatusClear();
    try {
        periodicBitsNumber = StrToInt(PeriodicBitsNumberEdit->Text);
        if ((periodicBitsNumber < 1) || (periodicBitsNumber > MAX_DIMENSION)) {
            StatusAlarm("Invalid number specified");
            if (periodicBitsNumber < 1)  periodicBitsNumber = 1;
            else                         periodicBitsNumber = MAX_DIMENSION;
        }
        if (par.periodicBitsNumber != periodicBitsNumber) {
            RootChanged();
            par.periodicBitsNumber = periodicBitsNumber;
            par.periodicBitsValue[0] &= mask[periodicBitsNumber % 8];
            BitsToNthRoot();
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowPeriodicBitsNumber();
    ShowPeriodicBitsValue();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetPeriodicBitsValue()
{
    char hexa[MAX_DIMENSION/4+2];

    strncpy(hexa, PeriodicBitsValueEdit->Text.c_str(), MAX_DIMENSION/4);
    hexa[MAX_DIMENSION/4] = 0;
    HexaToBits(par.periodicBitsNumber, par.periodicBitsValue, hexa);
    ShowPeriodicBitsValue();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetTopBitsNumber()
{
    int topBitsNumber;
    unsigned char mask[8] = { 0xff, 0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3f, 0x7f };

    StatusClear();
    try {
        topBitsNumber = StrToInt(TopBitsNumberEdit->Text);
        if (topBitsNumber > (par.dimension - par.lastBitsNumber)) {
            StatusAlarm("Top > Dimension-Last bits");
            topBitsNumber = par.dimension - par.lastBitsNumber;
        }
        if ((topBitsNumber < 0) || (topBitsNumber > MAX_DIMENSION)) {
            StatusAlarm("Invalid number specified");
            if (topBitsNumber < 0)  topBitsNumber = 0;
            else                    topBitsNumber = MAX_DIMENSION;
        }
        if (par.topBitsNumber != topBitsNumber) {
            RootChanged();
            par.topBitsNumber = topBitsNumber;
            par.topBitsValue[0] &= mask[topBitsNumber % 8];
            BitsToNthRoot();
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowTopBitsNumber();
    ShowTopBitsValue();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetTopBitsValue()
{
    char hexa[MAX_DIMENSION/4+2];

    strncpy(hexa, TopBitsValueEdit->Text.c_str(), MAX_DIMENSION/4);
    hexa[MAX_DIMENSION/4] = 0;
    HexaToBits(par.topBitsNumber, par.topBitsValue, hexa);
    ShowTopBitsValue();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetLastBitsNumber()
{
    int lastBitsNumber;
    unsigned char mask[8] = { 0xff, 0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3f, 0x7f };

    StatusClear();
    try {
        lastBitsNumber = StrToInt(LastBitsNumberEdit->Text);
        if (lastBitsNumber > (par.dimension - par.topBitsNumber)) {
            StatusAlarm("Last > Dimension-Top bits");
            lastBitsNumber = par.dimension - par.topBitsNumber;
        }
        if ((lastBitsNumber < 0) || (lastBitsNumber > MAX_DIMENSION)) {
            StatusAlarm("Invalid number specified");
            if (lastBitsNumber < 0)  lastBitsNumber = 0;
            else                     lastBitsNumber = MAX_DIMENSION;
        }
        if (par.lastBitsNumber != lastBitsNumber) {
            RootChanged();
            par.lastBitsNumber = lastBitsNumber;
            par.lastBitsValue[0] &= mask[lastBitsNumber % 8];
            BitsToNthRoot();
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowLastBitsNumber();
    ShowLastBitsValue();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetLastBitsValue()
{
    char hexa[MAX_DIMENSION/4+2];

    strncpy(hexa, LastBitsValueEdit->Text.c_str(), MAX_DIMENSION/4);
    hexa[MAX_DIMENSION/4] = 0;
    HexaToBits(par.lastBitsNumber, par.lastBitsValue, hexa);
    ShowLastBitsValue();
    ShowNthRoot();
}
//---------------------------------------------------------------------------
void TControlForm::SetAtRandom()
{
    if (AtRandomCheckBox->Checked == true) {
        if (par.nthRootAtRandom == 0)  RootChanged();
        par.nthRootAtRandom = 1;
    }
    else {
        par.nthRootAtRandom = 0;
    }
    ImageForm->changeSaveMenu();
}
//---------------------------------------------------------------------------
void TControlForm::SetAtRandomKind(int kind)
{
    if (par.nthRootAtRandom && (par.nthRootAtRandomKind != kind))  RootChanged();
    par.nthRootAtRandomKind = kind;
}
//---------------------------------------------------------------------------
void TControlForm::SetModifyBits()
{
    int nthRootModifyBits;

    StatusClear();
    try {
        nthRootModifyBits = StrToInt(ModifyBitsEdit->Text);
        if (nthRootModifyBits < 1) {
            StatusAlarm("Invalid number specified");
            nthRootModifyBits = 1;
        }
        if (par.nthRootModifyBits != nthRootModifyBits) {
            if (par.nthRootAtRandom)  RootChanged();
            par.nthRootModifyBits = nthRootModifyBits;
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowModifyBits();
}
//---------------------------------------------------------------------------
void TControlForm::SetCenterX()
{
    char buf[64];
    complex<PRECISION> center;

    StatusClear();
    sprintf(buf, "%.17Lf", img.center.real());
    if (strcmp(buf, RXEdit->Text.c_str()) == 0)  return;
    try {
        center = complex<PRECISION>(RXEdit->Text.ToDouble(), img.center.imag());
        img.center = center;
        if (img.onDrawing)  img.threadTerminate = 1;
        CenterChanged();
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowCenterX();
}
//---------------------------------------------------------------------------
void TControlForm::SetCenterY()
{
    char buf[64];
    complex<PRECISION> center;

    StatusClear();
    sprintf(buf, "%.17Lf", img.center.imag());
    if (strcmp(buf, RYEdit->Text.c_str()) == 0)  return;
    try {
        center = complex<PRECISION>(img.center.real(), RYEdit->Text.ToDouble());
        img.center = center;
        if (img.onDrawing)  img.threadTerminate = 1;
        CenterChanged();
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowCenterY();
}
//---------------------------------------------------------------------------
void TControlForm::SetSpanX()
{
    char buf[64];

    StatusClear();
    sprintf(buf, "%.17Lf", img.span[X]);
    if (strcmp(buf, SXEdit->Text.c_str()) == 0)  return;
    try {
        img.span[X] = SXEdit->Text.ToDouble();
        if (img.span[X] < 0.0000000000000001) {
            StatusAlarm("Invalid number specified");
            img.span[X] = 0.0000000000000001;
        }
        if (img.spanChanged == 0) {
            img.span[Y] = img.span[X] * par.imageSize[Y]/ par.imageSize[X];
        }
        if (img.onDrawing)  img.threadTerminate = 1;
        img.spanChanged = 1;
        CenterChanged();
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowSpanX();
    ShowSpanY();
}
//---------------------------------------------------------------------------
void TControlForm::SetSpanY()
{
    char buf[64];

    StatusClear();
    sprintf(buf, "%.17Lf", img.span[Y]);
    if (strcmp(buf, SYEdit->Text.c_str()) == 0)  return;
    try {
        img.span[Y] = SYEdit->Text.ToDouble();
        if (img.span[Y] < 0.0000000000000001) {
            StatusAlarm("Invalid number specified");
            img.span[Y] = 0.0000000000000001;
        }
        if (img.spanChanged == 0) {
            img.span[X] = img.span[Y] * par.imageSize[X]/ par.imageSize[Y];
        }
        if (img.onDrawing)  img.threadTerminate = 1;
        img.spanChanged = 1;
        CenterChanged();
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowSpanX();
    ShowSpanY();
}
//---------------------------------------------------------------------------
void TControlForm::SetMaxIter()
{
    int maxIter;

    StatusClear();
    try {
        maxIter = StrToInt(MaxIterEdit->Text);
        if (maxIter < 1) {
            StatusAlarm("Invalid number specified");
            maxIter = 1;
        }
        if (par.maxIter != maxIter) {
            if (img.onDrawing)  img.threadTerminate = 1;
            par.maxIter = maxIter;
            img.maxIterAuto = 0;
            FractalChanged();
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowMaxIter();
    ShowMaxIterAuto();
}
//---------------------------------------------------------------------------
void TControlForm::SetMaxIterAuto()
{
    if (MaxIterAutoCheckBox->Checked == true)  img.maxIterAuto = 1;
    else                                       img.maxIterAuto = 0;
}
//---------------------------------------------------------------------------
void TControlForm::SetRotationAngle()
{
    PRECISION rotationAngle;

    StatusClear();
    try {
        rotationAngle = RotationAngleEdit->Text.ToDouble() / (PRECISION)180.0 * (PRECISION)M_PI;
        if (par.rotationAngle != rotationAngle) {
            if (img.onDrawing)  img.threadTerminate = 1;
            par.rotationAngle = rotationAngle;
            FractalChanged();
        }
    }
    catch(EConvertError *e) {
        StatusInvalidNumeric();
    }
    ShowRotationAngle();
}
//---------------------------------------------------------------------------
void TControlForm::SetSaveImage()
{
    if (SaveImageCheckBox->Checked == true)  img.saveImage = 1;
    else                                     img.saveImage = 0;
}
//---------------------------------------------------------------------------
void TControlForm::SetSaveImageExt(int saveImageExt)
{
    img.saveImageExt = (IMAGE_EXT)saveImageExt;
}
//---------------------------------------------------------------------------
void TControlForm::ShowDimension()
{
    char buf[32];

    sprintf(buf, "%d", par.dimension);
    DimensionEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowNthRoot()
{
    char buf[MAX_DIMENSION/4+16];

    BitsToHexa(par.dimension, par.nthRoot, buf);
    NthRootEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowPeriodicBitsNumber()
{
    char buf[32];

    sprintf(buf, "%d", par.periodicBitsNumber);
    PeriodicBitsNumberEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowPeriodicBitsValue()
{
    char buf[MAX_DIMENSION/4+16];

    BitsToHexa(par.periodicBitsNumber, par.periodicBitsValue, buf);
    PeriodicBitsValueEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowTopBitsNumber()
{
    char buf[32];

    sprintf(buf, "%d", par.topBitsNumber);
    TopBitsNumberEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowTopBitsValue()
{
    char buf[MAX_DIMENSION/4+16];

    BitsToHexa(par.topBitsNumber, par.topBitsValue, buf);
    TopBitsValueEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowLastBitsNumber()
{
    char buf[32];

    sprintf(buf, "%d", par.lastBitsNumber);
    LastBitsNumberEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowLastBitsValue()
{
    char buf[MAX_DIMENSION/4+16];

    BitsToHexa(par.lastBitsNumber, par.lastBitsValue, buf);
    LastBitsValueEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowAtRandom()
{
    if (par.nthRootAtRandom)  AtRandomCheckBox->Checked = true;
    else                      AtRandomCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TControlForm::ShowAtRandomKind()
{
    if (par.nthRootAtRandomKind == 0)  ModifyBitsRadioButton->Checked = true;
    else                               FullRandomRadioButton->Checked = true;
}
//---------------------------------------------------------------------------
void TControlForm::ShowModifyBits()
{
    char buf[32];

    sprintf(buf, "%d", par.nthRootModifyBits);
    ModifyBitsEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowCenterX()
{
    char buf[64];

    sprintf(buf, "%.17Lf", img.center.real());
    RXEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowCenterY()
{
    char buf[64];

    sprintf(buf, "%.17Lf", img.center.imag());
    RYEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowSpanX()
{
    char buf[64];

    sprintf(buf, "%.17Lf", img.span[X]);
    SXEdit->Text = buf;
    ImageSizeForm->SpanXButton->Enabled = false;
    ImageSizeForm->SpanYButton->Enabled = false;
}
//---------------------------------------------------------------------------
void TControlForm::ShowSpanY()
{
    char buf[64];

    sprintf(buf, "%.17Lf", img.span[Y]);
    SYEdit->Text = buf;
    ImageSizeForm->SpanXButton->Enabled = false;
    ImageSizeForm->SpanYButton->Enabled = false;
}
//---------------------------------------------------------------------------
void TControlForm::ShowFractalChecked()
{
    if (par.formula == Mandelbrot)  MandelbrotRadioButton->Checked = true;
    else                            JuliaRadioButton->Checked = true;
}
//---------------------------------------------------------------------------
void TControlForm::ShowMaxIter()
{
    char buf[32];

    sprintf(buf, "%d", par.maxIter);
    MaxIterEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowMaxIterAuto()
{
    if (img.maxIterAuto)  MaxIterAutoCheckBox->Checked = true;
    else                  MaxIterAutoCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TControlForm::ShowRotationAngle()
{
    char buf[32];

    sprintf(buf, "%.2Lf", par.rotationAngle * (PRECISION)180.0 / (PRECISION)M_PI);
    RotationAngleEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TControlForm::ShowSaveImage()
{
    if (img.saveImage)  SaveImageCheckBox->Checked = true;
    else                SaveImageCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TControlForm::ShowSaveImageExt()
{
    if (img.saveImageExt == 0)  BMPRadioButton->Checked = true;
    else                        JPGRadioButton->Checked = true;
}
//---------------------------------------------------------------------------
void TControlForm::ShowAll()
{
    ShowDimension();
    ShowNthRoot();
    ShowPeriodicBitsNumber();
    ShowPeriodicBitsValue();
    ShowTopBitsNumber();
    ShowTopBitsValue();
    ShowLastBitsNumber();
    ShowLastBitsValue();
    ShowAtRandom();
    ShowAtRandomKind();
    ShowModifyBits();
    ShowCenterX();
    ShowCenterY();
    ShowSpanX();
    ShowSpanY();
    ShowFractalChecked();
    ShowMaxIter();
    ShowMaxIterAuto();
    ShowRotationAngle();
    ShowSaveImage();
    ShowSaveImageExt();
}
//---------------------------------------------------------------------------
void TControlForm::StatusClear()
{
    StatusMessage("");
}
//---------------------------------------------------------------------------
void TControlForm::StatusInvalidNumeric()
{
    StatusAlarm("Invalid numeric specified");
}
//---------------------------------------------------------------------------
void TControlForm::StatusMessage(char *message)
{
    StatusLabel->Font->Color = clWindowText;
    StatusLabel->Caption = message;
}
//---------------------------------------------------------------------------
void TControlForm::StatusAlarm(char *alarm)
{
    StatusLabel->Font->Color = clRed;
    StatusLabel->Caption = alarm;
}
//---------------------------------------------------------------------------
void HexaToBits(int bitsNumber, unsigned char *bitsValue, char *hexa)
{
    int  i, j, k, n, m;
    char *p;
    unsigned char bitsVal[MAX_DIMENSION/8], val;
    unsigned char mask[8] = { 0xff, 0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3f, 0x7f };

    ControlForm->StatusClear();
    for (i = 0; i < MAX_DIMENSION/8; bitsVal[i] = *(bitsValue + i), i++);
    p = hexa;
    n = strlen(p);
    m = bitsNumber / 4;
    if (bitsNumber % 4)  m++;
    if (n > m)  n = m;
    if (((bitsNumber - 1) % 8) < 4)  k = 1;
    else                             k = 0;
    for (i = j = 0; i < n; ) {
        if ((*p >= '0') && (*p <= '9'))       val = (unsigned char)(*p - '0');
        else if ((*p >= 'a') && (*p <= 'f'))  val = (unsigned char)(*p - 'a' + 0xA);
        else if ((*p >= 'A') && (*p <= 'F'))  val = (unsigned char)(*p - 'A' + 0xA);
        else break;
        if ((k % 2) == 0) {
            bitsVal[j] &= 0x0f;
            val <<= 4;
        }
        else {
            bitsVal[j] &= 0xf0;
        }
        bitsVal[j] |= val;
        i++;
        k++;
        p++;
        if ((k % 2) == 0)  j++;
    }
    if (i != n)  ControlForm->StatusAlarm("Invalid hexa numeric specified");
    else {
        bitsVal[0] &= mask[bitsNumber % 8];
        for (i = 0; i < MAX_DIMENSION/8; i++) {
            if (*(bitsValue + i) != bitsVal[i])  break;
        }
        if (i != MAX_DIMENSION/8) {
            RootChanged();
            for (i = 0; i < MAX_DIMENSION/8; *(bitsValue + i) = bitsVal[i], i++);
            if (bitsValue != par.nthRoot)  BitsToNthRoot();
        }
    }
}
//---------------------------------------------------------------------------
void BitsToHexa(int bitsNumber, unsigned char *bitsValue, char *hexa)
{
    int  i, j;
    char buf1[16];

    j = bitsNumber / 8;
    if (bitsNumber % 8)  j++;
    for (i = 0, hexa[0] = 0; i < j; i++) {
        if ((i == 0) && (((bitsNumber - 1) % 8) < 4))  sprintf(buf1, "%.1X", bitsValue[i]);
        else                                           sprintf(buf1, "%.2X", bitsValue[i]);
        strcat(hexa, buf1);
    }
}
//---------------------------------------------------------------------------
void BitsToNthRoot()
{
    int i;

    for (i = 0; i < MAX_DIMENSION/8; par.nthRoot[i++] = 0);
    PeriodicBitsToNthRoot();
    TopBitsToNthRoot();
    LastBitsToNthRoot();
}
//---------------------------------------------------------------------------
void PeriodicBitsToNthRoot()
{
    int pBit, nBit, p, n;

    p = par.periodicBitsNumber;
    n = par.dimension;
    if (n == 0)  return;
    par.nthRoot[0] = 0;
    pBit = rightAlign(p);
    nBit = rightAlign(n);
    while (n > 0) {
        if (n < p)  p = n;
        bitcpy(par.nthRoot, nBit, par.periodicBitsValue, pBit, -p);
        nBit -= p;
        n -= p;
    }
}
//---------------------------------------------------------------------------
void TopBitsToNthRoot()
{
    int tBit, nBit, t, n;

    t = par.topBitsNumber;
    n = par.dimension;
    if (n == 0)  return;
    tBit = rightAlign(t);
    nBit = rightAlign(n);
    bitcpy(par.nthRoot, nBit - (n - t), par.topBitsValue, tBit, -t);
}
//---------------------------------------------------------------------------
void LastBitsToNthRoot()
{
    int lBit, nBit, l, n;

    l = par.lastBitsNumber;
    n = par.dimension;
    if (n == 0)  return;
    lBit = rightAlign(l);
    nBit = rightAlign(n);
    bitcpy(par.nthRoot, nBit, par.lastBitsValue, lBit, -l);
}
//---------------------------------------------------------------------------
void ModifyOneBitOfNthRoot(float rand)
{
    int bitpos, j, m;

    if (par.dimension <= par.topBitsNumber + par.lastBitsNumber)  return;
    bitpos  = 7 - (par.dimension - 1) % 8 + par.topBitsNumber;
    bitpos += (par.dimension - par.topBitsNumber - par.lastBitsNumber) * rand;
    j = bitpos / 8;
    m = 7 - bitpos % 8;
    if (par.nthRoot[j] & (1 << m))  par.nthRoot[j] &= (unsigned char)~(1 << m);
    else                            par.nthRoot[j] |= (unsigned char)(1 << m);
}
//---------------------------------------------------------------------------
void ClearChanged()
{
    img.onZoom         = 0;
    img.fractalChanged = 0;
    img.rootChanged    = 0;
    img.centerChanged  = 0;
    img.spanChanged    = 0;
    ImageForm->changeSaveMenu();
    if (init.zoomAutoChange) {
        if (init.zoomModeDefault)  img.zoomMode = init.zoomModeDefault;
        else                       img.zoomMode = 8;
        ZoomForm->ShowZoomModeChecked();
    }
}
//---------------------------------------------------------------------------
void FractalChanged()
{
    img.fractalCalculationCompleted = 0;
    img.onZoom         = 0;
    img.fractalChanged = 1;
    ImageForm->changeSaveMenu();
}
//---------------------------------------------------------------------------
void RootChanged()
{
    RootChangedStop();
    img.maxIterAuto = 1;
    ControlForm->ShowMaxIterAuto();
}
//---------------------------------------------------------------------------
void RootChangedStop()
{
    if (img.onDrawing != Non)  TerminateThread((void *)img.threads->Handle, 0);
    calculationStopped();
    RootChangedNonStop();
}
//---------------------------------------------------------------------------
void RootChangedNonStop()          
{
    img.fractalChanged = 0;
    img.rootChanged    = 1;
    img.centerChanged  = 0;
    img.spanChanged    = 0;
    ImageForm->changeSaveMenu();
    if (init.zoomAutoChange) {
        img.zoomMode = 0;
        ZoomForm->ShowZoomModeChecked();
    }
}
//---------------------------------------------------------------------------
void CenterChanged()
{
    img.fractalCalculationCompleted = 0;
    img.rootChanged   = 0;
    img.centerChanged = 1;
    ClearDimension();
    ImageForm->changeSaveMenu();
    if (init.zoomAutoChange) {
        if (init.zoomModeDefault)  img.zoomMode = init.zoomModeDefault;
        else                       img.zoomMode = 8;
        ZoomForm->ShowZoomModeChecked();
    }
}
//---------------------------------------------------------------------------
void ChangeRootLabel(int root)
{
    if (root) {
        ControlForm->CenterLabel->Visible = false;
        ControlForm->RootLabel->Visible   = true;
    }
    else {
        ControlForm->RootLabel->Visible   = false;
        ControlForm->CenterLabel->Visible = true;
    }
}
//---------------------------------------------------------------------------
void ClearDimension()
{
    par.dimension            = 0;
    par.periodicBitsNumber   = 1;
    par.periodicBitsValue[0] = 0x01;
    par.topBitsNumber        = 0;
    par.topBitsValue[0]      = 0x00;
    par.lastBitsNumber       = 0;
    par.lastBitsValue[0]     = 0x00;
    par.nthRootAtRandom      = 0;
    par.nthRootAtRandomKind  = 0;
    par.nthRootModifyBits    = 1;
    BitsToNthRoot();
    img.maxIterAuto = 0;
    FindingRootForm->NonStopCheckBox->Checked = false;
    ControlForm->ShowDimension();
    ControlForm->ShowNthRoot();
    ControlForm->ShowPeriodicBitsNumber();
    ControlForm->ShowPeriodicBitsValue();
    ControlForm->ShowTopBitsNumber();
    ControlForm->ShowTopBitsValue();
    ControlForm->ShowLastBitsNumber();
    ControlForm->ShowLastBitsValue();
    ControlForm->ShowAtRandom();
    ControlForm->ShowAtRandomKind();
    ControlForm->ShowModifyBits();
    ControlForm->ShowMaxIterAuto();
}
//---------------------------------------------------------------------------


