//---------------------------------------------------------------------------
#ifndef ControlH
#define ControlH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#define WM_ROOT_ON_PAINT     (WM_APP + 1)
#define WM_ROOT_CALC_END     (WM_APP + 2)
//---------------------------------------------------------------------------
class TControlForm : public TForm
{
__published:
    TButton *StartButton;
    TButton *ResetButton;

    TLabel *DimensionLabel;
    TEdit *DimensionEdit;

    TGroupBox *NthRootGroupBox;
    TEdit *NthRootEdit;
    TLabel *BitNumberLabel;
    TLabel *BitValueLabel;
    TLabel *PeriodicBitsLabel;
    TEdit *PeriodicBitsNumberEdit;
    TEdit *PeriodicBitsValueEdit;
    TLabel *TopBitsLabel;
    TEdit *TopBitsNumberEdit;
    TEdit *TopBitsValueEdit;
    TLabel *LastBitsLabel;
    TEdit *LastBitsNumberEdit;
    TEdit *LastBitsValueEdit;
    TCheckBox *AtRandomCheckBox;
    TRadioButton *ModifyBitsRadioButton;
    TEdit *ModifyBitsEdit;
    TLabel *ModifyBitsLabel;
    TRadioButton *FullRandomRadioButton;

    TImage *Image;

    TButton *FindingRootButton;
    TGroupBox *StatusGroupBox;
    TLabel *StatusLabel;

    TLabel *CenterLabel;
    TLabel *RootLabel;
    TLabel *XLabel;
    TEdit *RXEdit;
    TLabel *YLabel;
    TEdit *RYEdit;
    TLabel *SpanLabel;
    TEdit *SXEdit;
    TEdit *SYEdit;

    TGroupBox *FractalGroupBox;
    TLabel *FractalLabel;
    TRadioButton *MandelbrotRadioButton;
    TRadioButton *JuliaRadioButton;

    TLabel *MaxIterLabel;
    TEdit *MaxIterEdit;
    TCheckBox *MaxIterAutoCheckBox;

    TLabel *RotationAngleLabel;
    TEdit *RotationAngleEdit;

    TButton *HideButton;

    TGroupBox *SaveGroupBox;
    TCheckBox *SaveImageCheckBox;
    TRadioButton *BMPRadioButton;
    TRadioButton *JPGRadioButton;

    void __fastcall StartButtonClick(TObject *Sender);
    void __fastcall ResetButtonClick(TObject *Sender);
    void __fastcall DimensionEditExit(TObject *Sender);
    void __fastcall DimensionEditKeyPress(TObject *Sender, char &Key);
    void __fastcall NthRootEditExit(TObject *Sender);
    void __fastcall NthRootEditKeyPress(TObject *Sender, char &Key);
    void __fastcall PeriodicBitsNumberEditExit(TObject *Sender);
    void __fastcall PeriodicBitsNumberEditKeyPress(TObject *Sender, char &Key);
    void __fastcall PeriodicBitsValueEditExit(TObject *Sender);
    void __fastcall PeriodicBitsValueEditKeyPress(TObject *Sender, char &Key);
    void __fastcall TopBitsNumberEditExit(TObject *Sender);
    void __fastcall TopBitsNumberEditKeyPress(TObject *Sender, char &Key);
    void __fastcall TopBitsValueEditExit(TObject *Sender);
    void __fastcall TopBitsValueEditKeyPress(TObject *Sender, char &Key);
    void __fastcall LastBitsNumberEditExit(TObject *Sender);
    void __fastcall LastBitsNumberEditKeyPress(TObject *Sender, char &Key);
    void __fastcall LastBitsValueEditExit(TObject *Sender);
    void __fastcall LastBitsValueEditKeyPress(TObject *Sender, char &Key);
    void __fastcall AtRandomCheckBoxClick(TObject *Sender);
    void __fastcall ModifyBitsRadioButtonClick(TObject *Sender);
    void __fastcall FullRandomRadioButtonClick(TObject *Sender);
    void __fastcall ModifyBitsEditExit(TObject *Sender);
    void __fastcall ModifyBitsEditKeyPress(TObject *Sender, char &Key);
    void __fastcall FindingRootButtonClick(TObject *Sender);
    void __fastcall RXEditExit(TObject *Sender);
    void __fastcall RXEditKeyPress(TObject *Sender, char &Key);
    void __fastcall RYEditExit(TObject *Sender);
    void __fastcall RYEditKeyPress(TObject *Sender, char &Key);
    void __fastcall SXEditExit(TObject *Sender);
    void __fastcall SXEditKeyPress(TObject *Sender, char &Key);
    void __fastcall SYEditExit(TObject *Sender);
    void __fastcall SYEditKeyPress(TObject *Sender, char &Key);
    void __fastcall MandelbrotRadioButtonClick(TObject *Sender);
    void __fastcall JuliaRadioButtonClick(TObject *Sender);
    void __fastcall MaxIterEditExit(TObject *Sender);
    void __fastcall MaxIterEditKeyPress(TObject *Sender, char &Key);
    void __fastcall MaxIterAutoCheckBoxClick(TObject *Sender);
    void __fastcall RotationAngleEditKeyPress(TObject *Sender, char &Key);
    void __fastcall RotationAngleEditExit(TObject *Sender);
    void __fastcall SaveImageCheckBoxClick(TObject *Sender);
    void __fastcall BMPRadioButtonClick(TObject *Sender);
    void __fastcall JPGRadioButtonClick(TObject *Sender);
    void __fastcall HideButtonClick(TObject *Sender);
private:
public:
    __fastcall TControlForm(TComponent* Owner);
    void SetDimension();
    void SetNthRoot();
    void SetPeriodicBitsNumber();
    void SetPeriodicBitsValue();
    void SetTopBitsNumber();
    void SetTopBitsValue();
    void SetLastBitsNumber();
    void SetLastBitsValue();
    void SetAtRandom();
    void SetAtRandomKind(int kind);
    void SetModifyBits();
    void SetCenterX();
    void SetCenterY();
    void SetSpanX();
    void SetSpanY();
    void SetMaxIter();
    void SetMaxIterAuto();
    void SetRotationAngle();
    void SetSaveImage();
    void SetSaveImageExt(int saveImageExt);
    void ShowDimension();
    void ShowNthRoot();
    void ShowPeriodicBitsNumber();
    void ShowPeriodicBitsValue();
    void ShowTopBitsNumber();
    void ShowTopBitsValue();
    void ShowLastBitsNumber();
    void ShowLastBitsValue();
    void ShowAtRandom();
    void ShowAtRandomKind();
    void ShowModifyBits();
    void ShowCenterX();
    void ShowCenterY();
    void ShowSpanX();
    void ShowSpanY();
    void ShowFractalChecked();
    void ShowMaxIter();
    void ShowMaxIterAuto();
    void ShowRotationAngle();
    void ShowSaveImage();
    void ShowSaveImageExt();
    void ShowAll();
    void StatusClear();
    void StatusInvalidNumeric();
    void StatusMessage(char *message);
    void StatusAlarm(char *alarm);
protected:
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_ROOT_ON_PAINT, TMessage, RootOnPaintMessage)
        MESSAGE_HANDLER(WM_ROOT_CALC_END, TMessage, RootCalcEndMessage)
    END_MESSAGE_MAP(TForm)
    void __fastcall RootOnPaintMessage(TMessage &Message);
    void __fastcall RootCalcEndMessage(TMessage &Message);
};
//---------------------------------------------------------------------------
void HexaToBits(int bitsNumber, unsigned char *bitsValue, char *hexa);
void BitsToHexa(int bitsNumber, unsigned char *bitsValue, char *hexa);
void BitsToNthRoot();
void PeriodicBitsToNthRoot();
void TopBitsToNthRoot();
void LastBitsToNthRoot();
void ModifyOneBitOfNthRoot(float rand);
void ClearChanged();
void FractalChanged();
void RootChanged();
void RootChangedStop();
void RootChangedNonStop();
void CenterChanged();
void ChangeRootLabel(int root);
void ClearDimension();
extern PACKAGE TControlForm *ControlForm;
//---------------------------------------------------------------------------
#endif
