//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "EditColor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TEditColorForm *EditColorForm;
//---------------------------------------------------------------------------
__fastcall TEditColorForm::TEditColorForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::LoadMapButtonClick(TObject *Sender)
{
    ImageForm->LoadColorMapClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::WriteMapButtonClick(TObject *Sender)
{
    ImageForm->WriteColorMapClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::ColorDialogButtonClick(TObject *Sender)
{
    int color, i;

    if (ColorDialog->Execute() == false)  return;
    color = (int)ColorDialog->Color;
    img.changeColor[0] = color & 0xff;
    img.changeColor[1] = (color >> 8) & 0xff;
    img.changeColor[2] = (color >> 16) & 0xff;
    for (i = 0; i < 3; i++) {
        SetColor(i);
    }
    AjustVerticalScroll();
    ShowAll();
    Showfractal();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::RRadioButtonClick(TObject *Sender)
{
    img.editRGB = 0;
    AjustVerticalScroll();
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::GRadioButtonClick(TObject *Sender)
{
    img.editRGB = 1;
    AjustVerticalScroll();
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::BRadioButtonClick(TObject *Sender)
{
    img.editRGB = 2;
    AjustVerticalScroll();
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::LeftAnchorScrollBarChange(TObject *Sender)
{
    int pos;

    pos = LeftAnchorScrollBar->Position;
    if (pos > ChangePointScrollBar->Position)
        pos = ChangePointScrollBar->Position;
    if (pos >= RightAnchorScrollBar->Position)
        pos = RightAnchorScrollBar->Position - 1;
    LeftAnchorScrollBar->Position = pos;
    img.leftAnchor = pos;
    img.leftColor[0] = (int)par.lPal.pal.palPalEntry[pos].peRed;
    img.leftColor[1] = (int)par.lPal.pal.palPalEntry[pos].peGreen;
    img.leftColor[2] = (int)par.lPal.pal.palPalEntry[pos].peBlue;
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::RightAnchorScrollBarChange(TObject *Sender)
{
    int pos;

    pos = RightAnchorScrollBar->Position;
    if (pos < ChangePointScrollBar->Position)
        pos = ChangePointScrollBar->Position;
    if (pos <= LeftAnchorScrollBar->Position)
        pos = LeftAnchorScrollBar->Position + 1;
    RightAnchorScrollBar->Position = pos;
    img.rightAnchor = pos;
    img.rightColor[0] = (int)par.lPal.pal.palPalEntry[pos].peRed;
    img.rightColor[1] = (int)par.lPal.pal.palPalEntry[pos].peGreen;
    img.rightColor[2] = (int)par.lPal.pal.palPalEntry[pos].peBlue;
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::ChangePointScrollBarChange(TObject *Sender)
{
    int pos;

    pos = ChangePointScrollBar->Position;
    if (pos < LeftAnchorScrollBar->Position)
        pos = LeftAnchorScrollBar->Position;
    if (pos > RightAnchorScrollBar->Position)
        pos = RightAnchorScrollBar->Position;
    ChangePointScrollBar->Position = pos;
    img.changePoint = pos;
    img.changeColor[0] = (int)par.lPal.pal.palPalEntry[pos].peRed;
    img.changeColor[1] = (int)par.lPal.pal.palPalEntry[pos].peGreen;
    img.changeColor[2] = (int)par.lPal.pal.palPalEntry[pos].peBlue;
    AjustVerticalScroll();
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::HeightScrollBarChange(TObject *Sender)
{
    if (img.verticalScrollOnAjust)  return;
    img.changeColor[img.editRGB] = 255 - HeightScrollBar->Position;
    SetColor(img.editRGB);
    ShowAll();
    Showfractal();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::LeftGradientScrollBarChange(TObject *Sender)
{
    if (img.verticalScrollOnAjust)  return;
    img.leftGradient[img.editRGB] = - LeftGradientScrollBar->Position;
    SetColor(img.editRGB);
    ShowAll();
    Showfractal();
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::RightGradientScrollBarChange(TObject *Sender)
{
    if (img.verticalScrollOnAjust)  return;
    img.rightGradient[img.editRGB] = - RightGradientScrollBar->Position;
    SetColor(img.editRGB);
    ShowAll();
    Showfractal();
}
//---------------------------------------------------------------------------
void TEditColorForm::AjustVerticalScroll()
{
    img.verticalScrollOnAjust = 1;
    EditColorForm->HeightScrollBar->Position = 255 - img.changeColor[img.editRGB];
    EditColorForm->LeftGradientScrollBar->Position = - img.leftGradient[img.editRGB];
    EditColorForm->RightGradientScrollBar->Position = - img.rightGradient[img.editRGB];
    img.verticalScrollOnAjust = 0;
}
//---------------------------------------------------------------------------
void __fastcall TEditColorForm::FormHide(TObject *Sender)
{
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowColor()
{
    int i, j;
    BYTE *ptr;

    img.colorBitmap->Width  = 256;
    img.colorBitmap->Height = 64;
    img.colorBitmap->PixelFormat = pf8bit;
    img.colorBitmap->Palette     = CreatePalette(&par.lPal.pal);
    for (i = 0; i < 64; i++) {
        ptr = (BYTE *)img.colorBitmap->ScanLine[i];
        for (j = 0; j < 256; *(ptr++) = (BYTE)j++);
    }
    EditColorForm->ColorImage->Picture->Graphic = img.colorBitmap;
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowRGB(int rgb)
{
    int i, y;
    TImage *rgbImage[] = {RImage, GImage, BImage};

    img.rgbBitmap[rgb]->Width  = 256;
    img.rgbBitmap[rgb]->Height = 64;
    img.rgbBitmap[rgb]->PixelFormat = pf8bit;
    img.rgbBitmap[rgb]->Canvas->Brush->Color = clWhite;
    img.rgbBitmap[rgb]->Canvas->FillRect(TRect(0, 0, 256, 64));
    img.rgbBitmap[rgb]->Canvas->Pen->Color = clBlack;
    for (i = 0;i < 256;i++) {
        switch (rgb) {
        case 0:
             y = (int)par.lPal.pal.palPalEntry[i].peRed;
             break;
        case 1:
             y = (int)par.lPal.pal.palPalEntry[i].peGreen;
             break;
        case 2:
             y = (int)par.lPal.pal.palPalEntry[i].peBlue;
             break;
        }
        y = 63 - y / 4;
        if (i == 0)
            img.rgbBitmap[rgb]->Canvas->MoveTo(i, y);
        else
            img.rgbBitmap[rgb]->Canvas->LineTo(i, y);
    }
    rgbImage[rgb]->Picture->Graphic = img.rgbBitmap[rgb];
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowLeftAnchor()
{
    TImage *rgbImage[] = {RImage, GImage, BImage};

    img.rgbBitmap[img.editRGB]->Canvas->Pen->Color = clGreen;
    img.rgbBitmap[img.editRGB]->Canvas->MoveTo(img.leftAnchor, 64);
    img.rgbBitmap[img.editRGB]->Canvas->LineTo(img.leftAnchor, 0);
    rgbImage[img.editRGB]->Picture->Graphic = img.rgbBitmap[img.editRGB];
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowRightAnchor()
{
    TImage *rgbImage[] = {RImage, GImage, BImage};

    img.rgbBitmap[img.editRGB]->Canvas->Pen->Color = clGreen;
    img.rgbBitmap[img.editRGB]->Canvas->MoveTo(img.rightAnchor, 64);
    img.rgbBitmap[img.editRGB]->Canvas->LineTo(img.rightAnchor, 0);
    rgbImage[img.editRGB]->Picture->Graphic = img.rgbBitmap[img.editRGB];
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowChangePoint()
{
    TImage *rgbImage[] = {RImage, GImage, BImage};

    img.rgbBitmap[img.editRGB]->Canvas->Pen->Color = clRed;
    img.rgbBitmap[img.editRGB]->Canvas->MoveTo(img.changePoint, 64);
    img.rgbBitmap[img.editRGB]->Canvas->LineTo(img.changePoint, 0);
    rgbImage[img.editRGB]->Picture->Graphic = img.rgbBitmap[img.editRGB];
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowLeftGradient()
{
    int y, color;
    float rad, s, c, a;
    TImage *rgbImage[] = {RImage, GImage, BImage};

    img.rgbBitmap[img.editRGB]->Canvas->Pen->Color = clBlue;
    if (img.changePoint == img.leftAnchor)  color = img.changeColor[img.editRGB];
    else                                    color = img.leftColor[img.editRGB];
    y = 63 - color / 4;
    img.rgbBitmap[img.editRGB]->Canvas->MoveTo(img.leftAnchor, y);
    rad = (float)img.leftGradient[img.editRGB] / 180.0 * M_PI;
    s = sin(rad);
    c = cos(rad);
    a = 1.0 / sqrt(s * s / 16.0 + c * c);
    y = 63 - (color + 30 * a * s) / 4;
    img.rgbBitmap[img.editRGB]->Canvas->LineTo(img.leftAnchor + 30 * a * c, y);
    rgbImage[img.editRGB]->Picture->Graphic = img.rgbBitmap[img.editRGB];
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowRightGradient()
{
    int y, color;
    float rad, s, c, a;
    TImage *rgbImage[] = {RImage, GImage, BImage};

    img.rgbBitmap[img.editRGB]->Canvas->Pen->Color = clBlue;
    if (img.changePoint == img.rightAnchor)  color = img.changeColor[img.editRGB];
    else                                     color = img.rightColor[img.editRGB];
    y = 63 - color / 4;
    img.rgbBitmap[img.editRGB]->Canvas->MoveTo(img.rightAnchor, y);
    rad = (float)img.rightGradient[img.editRGB] / 180.0 * M_PI;
    s = sin(rad);
    c = cos(rad);
    a = 1.0 / sqrt(s * s / 16.0 + c * c);
    y = 63 - (color + 30 * a * s) / 4;
    img.rgbBitmap[img.editRGB]->Canvas->LineTo(img.rightAnchor - 30 * a * c, y);
    rgbImage[img.editRGB]->Picture->Graphic = img.rgbBitmap[img.editRGB];
}
//---------------------------------------------------------------------------
void TEditColorForm::Showfractal()
{
    changePalette();
    ImageForm->Image->Picture->Graphic = img.fractalBitmap;
}
//---------------------------------------------------------------------------
void TEditColorForm::ShowAll()
{
    int i;

    ShowColor();
    for (i = 0;i < 3;i++) {
        ShowRGB(i);
    }
    ShowLeftAnchor();
    ShowRightAnchor();
    ShowChangePoint();
    ShowLeftGradient();
    ShowRightGradient();
}
//---------------------------------------------------------------------------
void TEditColorForm::SetColor(int rgb)
{
    double a[5][6], c[4][5], x , y, b[5];
    int i, j;

    if ((img.changePoint != img.leftAnchor) && (img.changePoint != img.rightAnchor)) {
        a[0][5] = img.leftColor[rgb];
        a[1][5] = img.changeColor[rgb];
        a[2][5] = img.rightColor[rgb];
        a[3][5] = tan((float)img.leftGradient[rgb] / 180.0 * M_PI);
        a[4][5] = -tan((float)img.rightGradient[rgb] / 180.0 * M_PI);
        for (i = 0; i < 3; i++) {
            switch (i) {
            case 0:
                x = img.leftAnchor;
                break;
            case 1:
                x = img.changePoint;
                break;
            case 2:
                x = img.rightAnchor;
                break;
            }
            a[i][4] = 1.0;
            for (j = 3; j >= 0; j--) {
                a[i][j] = a[i][j + 1] * x;
            }
        }
        for ( ; i < 5; i++) {
            switch (i) {
            case 3:
                x = img.leftAnchor;
                break;
            case 4:
                x = img.rightAnchor;
                break;
            }
            a[i][4] = 0.0;
            a[i][3] = 1.0;
            y = 1.0;
            for (j = 2; j >= 0; j--) {
                a[i][j] = a[i][j + 1] * x * (4.0 - j) / y;
                y = (4.0 - j);
            }
        }
        if (GaussJordan(5, &a[0][0], &b[0]))  return;
        for (i = img.leftAnchor; i <= img.rightAnchor; i++) {
            y = 0.0;
            x = 1.0;
            for (j = 4; j >= 0; j--) {
                y += b[j] * x;
                x *= i;
            }
            if (y > 255)  y = 255;
            if (y < 0)    y = 0;
            switch (rgb) {
            case 0:
                par.lPal.pal.palPalEntry[i].peRed = (BYTE)y;
                break;
            case 1:
                par.lPal.pal.palPalEntry[i].peGreen = (BYTE)y;
                break;
            case 2:
                par.lPal.pal.palPalEntry[i].peBlue = (BYTE)y;
                break;
            }
        }
    }
    else {
        if (img.changePoint == img.leftAnchor) {
            c[0][4] = img.changeColor[rgb];
            c[1][4] = img.rightColor[rgb];
        }
        else {
            c[0][4] = img.leftColor[rgb];
            c[1][4] = img.changeColor[rgb];
        }
        c[2][4] = tan((float)img.leftGradient[rgb] / 180.0 * M_PI);
        c[3][4] = -tan((float)img.rightGradient[rgb] / 180.0 * M_PI);
        for (i = 0; i < 2; i++) {
            switch (i) {
            case 0:
                x = img.leftAnchor;
                break;
            case 1:
                x = img.rightAnchor;
                break;
            }
            c[i][3] = 1.0;
            for (j = 2; j >= 0; j--) {
                c[i][j] = c[i][j + 1] * x;
            }
        }
        for ( ; i < 4; i++) {
            switch (i) {
            case 2:
                x = img.leftAnchor;
                break;
            case 3:
                x = img.rightAnchor;
                break;
            }
            c[i][3] = 0.0;
            c[i][2] = 1.0;
            y = 1.0;
            for (j = 1; j >= 0; j--) {
                c[i][j] = c[i][j + 1] * x * (3.0 - j) / y;
                y = (3.0 - j);
            }
        }
        if (GaussJordan(4, &c[0][0], &b[0]))  return;
        for (i = img.leftAnchor; i <= img.rightAnchor; i++) {
            y = 0.0;
            x = 1.0;
            for (j = 3; j >= 0; j--) {
                y += b[j] * x;
                x *= i;
            }
            if (y > 255)  y = 255;
            if (y < 0)    y = 0;
            switch (rgb) {
            case 0:
                par.lPal.pal.palPalEntry[i].peRed = (BYTE)y;
                break;
            case 1:
                par.lPal.pal.palPalEntry[i].peGreen = (BYTE)y;
                break;
            case 2:
                par.lPal.pal.palPalEntry[i].peBlue = (BYTE)y;
                break;
            }
        }
    }
}
//---------------------------------------------------------------------------
int GaussJordan(int n, double *aa, double *b)
{
	double **a, temp, *p;
	int i, j, k;

	a = (double **)malloc(sizeof(double *) * n);
	if (a == NULL)  return 1;
	for (i = 0; i < n; i++)
		a[i] = aa + i * (n + 1);
	for (i = 0; i < n; i++) {
		k = i;
		temp = fabs(a[i][i]);
		for (j = i + 1; j < n; j++)
			if (fabs(a[j][i]) > temp) {
				k = j;
				temp = fabs(a[j][i]);
			}
		if (k != i) {
			p = a[i];
			a[i] = a[k];
			a[k] = p;
		}
        if (fabs(a[i][i]) < 0.000001)  return 1;
		temp = 1.0 / a[i][i];
		for (j = i; j <= n; j++)
			a[i][j] *= temp;
		for (j = 0; j < n; j++)
			if (j != i) {
				temp = a[j][i];
				for (k = i; k <= n; k++)
					a[j][k] -= temp * a[i][k];
			}
	}
	for (i = 0; i < n; i++)
        b[i] = a[i][n];
    return 0;
}
//---------------------------------------------------------------------------

