//---------------------------------------------------------------------------
#ifndef EditColorH
#define EditColorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TEditColorForm : public TForm
{
__published:
    TImage *ColorImage;
    TImage *RImage;
    TImage *GImage;
    TImage *BImage;
    TLabel *ColorLabel;
    TLabel *LeftAnchorLabel;
    TLabel *RightAnchorLabel;
    TLabel *ChangePointLabel;
    TLabel *HeightLabel;
    TLabel *LeftGradientLabel;
    TLabel *RightGradientLabel;
    TButton *LoadMapButton;
    TButton *WriteMapButton;
    TButton *HideButton;
    TButton *ColorDialogButton;
    TRadioButton *RRadioButton;
    TRadioButton *GRadioButton;
    TRadioButton *BRadioButton;
    TScrollBar *LeftAnchorScrollBar;
    TScrollBar *RightAnchorScrollBar;
    TScrollBar *ChangePointScrollBar;
    TScrollBar *HeightScrollBar;
    TScrollBar *LeftGradientScrollBar;
    TScrollBar *RightGradientScrollBar;
    TColorDialog *ColorDialog;
    void __fastcall LoadMapButtonClick(TObject *Sender);
    void __fastcall WriteMapButtonClick(TObject *Sender);
    void __fastcall HideButtonClick(TObject *Sender);
    void __fastcall ColorDialogButtonClick(TObject *Sender);
    void __fastcall RRadioButtonClick(TObject *Sender);
    void __fastcall GRadioButtonClick(TObject *Sender);
    void __fastcall BRadioButtonClick(TObject *Sender);
    void __fastcall LeftAnchorScrollBarChange(TObject *Sender);
    void __fastcall RightAnchorScrollBarChange(TObject *Sender);
    void __fastcall ChangePointScrollBarChange(TObject *Sender);
    void __fastcall HeightScrollBarChange(TObject *Sender);
    void __fastcall LeftGradientScrollBarChange(TObject *Sender);
    void __fastcall RightGradientScrollBarChange(TObject *Sender);
    void __fastcall FormHide(TObject *Sender);
private:
public:
    __fastcall TEditColorForm(TComponent* Owner);
    void AjustVerticalScroll();
    void ShowColor();
    void ShowRGB(int rgb);
    void ShowLeftAnchor();
    void ShowRightAnchor();
    void ShowChangePoint();
    void ShowLeftGradient();
    void ShowRightGradient();
    void Showfractal();
    void ShowAll();
    void SetColor(int rgb);
};
//---------------------------------------------------------------------------
int GaussJordan(int n, double *a, double *b);
extern PACKAGE TEditColorForm *EditColorForm;
//---------------------------------------------------------------------------
#endif
