//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "FindingRoot.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFindingRootForm *FindingRootForm;
//---------------------------------------------------------------------------
__fastcall TFindingRootForm::TFindingRootForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::NonStopCheckBoxClick(TObject *Sender)
{
    SetNonStop();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::WithoutFractalRadioButtonClick(TObject *Sender)
{
    SetWithFractal();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::WithFractalRadioButtonClick(TObject *Sender)
{
    SetWithFractal();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::HiddenAreaCheckBoxClick(TObject *Sender)
{
    SetHiddenArea();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::ZoomInPowerEditExit(TObject *Sender)
{
    SetZoomInPower();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::ZoomInPowerEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetZoomInPower();
    else              img.zoomInPowerOnEdit = 1;
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::MaxRetryEditExit(TObject *Sender)
{
    SetMaxRetry();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::MaxRetryEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetMaxRetry();
    else              img.maxRetryOnEdit = 1;
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::MaxRetryAutoCheckBoxClick(TObject *Sender)
{
    SetMaxRetryAuto();
}
//---------------------------------------------------------------------------
void __fastcall TFindingRootForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void TFindingRootForm::SetNonStop()
{
    if (NonStopCheckBox->Checked == true) {
        RootChanged();
        WithFractalRadioButton->Enabled    = true;
        WithoutFractalRadioButton->Enabled = true;
        ControlForm->JuliaRadioButton->Enabled = false;
        img.rootFindNonStop      = 1;
        img.rootFindHiddenArea   = 1;
        img.rootFindWithFractal  = 1;
        img.rootFindZoomInPower  = 3.0;
        img.rootFindRetryMax     = 22;
        img.rootFindRetryMaxAuto = 0;
        img.onZoom               = 0;
        par.formula              = Mandelbrot;
        par.maxIter              = DEFAULT_MAXITER;
        ControlForm->ShowFractalChecked();
        ControlForm->ShowMaxIter();
        imageFormInitialize(2);
    }
    else {
        RootChanged();
        WithFractalRadioButton->Enabled    = false;
        WithoutFractalRadioButton->Enabled = false;
        ControlForm->JuliaRadioButton->Enabled = true;
        img.rootFindNonStop      = 0;
        img.rootFindHiddenArea   = 1;
        img.rootFindWithFractal  = 0;
        img.rootFindZoomInPower  = ROOT_FIND_TRIAL_ZOOM_POWER;
        img.rootFindRetryMax     = 5;
        img.rootFindRetryMaxAuto = 1;
        img.threadTerminate      = 1;
        ImageForm->changeSaveMenu();
    }
    ShowAll();
}
//---------------------------------------------------------------------------
void TFindingRootForm::SetWithFractal()
{
    if (WithFractalRadioButton->Checked == true)  img.rootFindWithFractal = 1;
    else                                          img.rootFindWithFractal = 0;
}
//---------------------------------------------------------------------------
void TFindingRootForm::SetHiddenArea()
{
    if (HiddenAreaCheckBox->Checked == true)  img.rootFindHiddenArea = 1;
    else                                      img.rootFindHiddenArea = 0;
}
//---------------------------------------------------------------------------
void TFindingRootForm::SetZoomInPower()
{
    PRECISION zoomInPower;

    img.zoomInPowerOnEdit = 0;
    try {
        zoomInPower = ZoomInPowerEdit->Text.ToDouble();
        if ((zoomInPower < 1.01) || (zoomInPower > 20.0)) {
            ShowMessage("Invalid number specified");
            if (zoomInPower < 1.01)  zoomInPower = 1.01;
            else                     zoomInPower = 20.0;
        }
        img.rootFindZoomInPower = zoomInPower;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowZoomInPower();
}
//---------------------------------------------------------------------------
void TFindingRootForm::SetMaxRetry()
{
    int maxRetry;

    img.maxRetryOnEdit = 0;
    try {
        maxRetry = StrToInt(MaxRetryEdit->Text);
        if (maxRetry < 1) {
            ShowMessage("Invalid number specified");
            maxRetry = 1;
        }
        img.rootFindRetryMax = maxRetry;
        img.rootFindRetryMaxAuto = 0;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowMaxRetry();
    ShowMaxRetryAuto();
}
//---------------------------------------------------------------------------
void TFindingRootForm::SetMaxRetryAuto()
{
    if (MaxRetryAutoCheckBox->Checked == true)  img.rootFindRetryMaxAuto = 1;
    else                                        img.rootFindRetryMaxAuto = 0;
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowNonStop()
{
    if (img.rootFindNonStop)  NonStopCheckBox->Checked = true;
    else                      NonStopCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowWithFractal()
{
    if (img.rootFindWithFractal) {
        WithFractalRadioButton->Checked = true;
        WithoutFractalRadioButton->Checked = false;
    }
    else {
        WithFractalRadioButton->Checked = false;
        WithoutFractalRadioButton->Checked = true;
    }
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowHiddenArea()
{
    if (img.rootFindHiddenArea)  HiddenAreaCheckBox->Checked = true;
    else                         HiddenAreaCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowZoomInPower()
{
    char buf[32];

    sprintf(buf, "%.2Lf", img.rootFindZoomInPower);
    ZoomInPowerEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowMaxRetry()
{
    char buf[32];

    sprintf(buf, "%d", img.rootFindRetryMax);
    MaxRetryEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowMaxRetryAuto()
{
    if (img.rootFindRetryMaxAuto)  MaxRetryAutoCheckBox->Checked = true;
    else                           MaxRetryAutoCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TFindingRootForm::ShowAll()
{
    ShowNonStop();
    ShowWithFractal();
    ShowHiddenArea();
    ShowZoomInPower();
    ShowMaxRetry();
    ShowMaxRetryAuto();
}
//---------------------------------------------------------------------------

