//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "FindingRoot.h"
#include "Option.h"
#include "ReverseAnalysis.h"
#include "BodyAndHead.h"
#include "Spiral.h"
#include "LowDimension.h"
#include "ImageSize.h"
#include "Zoom.h"
#include "EditColor.h"
#include "ZoomInMovie.h"
#include "SelfSimilarityMovie.h"
#include "MovieControl.h"
#include "About.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TImageForm *ImageForm;
//---------------------------------------------------------------------------
__fastcall TImageForm::TImageForm(TComponent* Owner)
    : TForm(Owner)
{
    mouseOnDown = 0;
    prevOnShow  = 0;
    zoomFormShowed = 0;
    Top  = 4;
    Left = 335;
    AutoSize = false;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::FormResize(TObject *Sender)
{
    HorzScrollBar->Position = 0;
    VertScrollBar->Position = 0;
    if (ClientWidth > Image->Width)    Image->Left = (ClientWidth - Image->Width) / 2;
    else                               Image->Left = 0;
    if (ClientHeight > Image->Height)  Image->Top  = (ClientHeight - Image->Height) / 2;
    else                               Image->Top  = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::OpenDemoClick(TObject *Sender)
{
    char dir[MAXPATH];

    tempStopRequest();
    OpenDialog->Filter = "Demo files (*.demo)|*.DEMO";
    OpenDialog->FileName = "";
    strcpy(dir, img.demoPath.drive);
    strcat(dir, img.demoPath.dir);
    OpenDialog->InitialDir = dir;
    if (OpenDialog->Execute()) {
        stopForOpen();
        img.threadTempStop = 0;
        if (openDemo(OpenDialog->FileName.c_str(), "") == false)  return;
        img.clickIgnore = 1;
        startDemo();
    }
    else  img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::OpenClick(TObject *Sender)
{
    char dir[MAXPATH];

    tempStopRequest();
    OpenDialog->Filter = "Parameter files (*.par)|*.PAR";
    OpenDialog->FileName = "";
    strcpy(dir, img.openPath.drive);
    strcat(dir, img.openPath.dir);
    OpenDialog->InitialDir = dir;
    img.movImageOpened = 0;
    if (OpenDialog->Execute()) {
        stopForOpen();
        img.threadTempStop = 0;
        setOpenPath(OpenDialog->FileName.c_str(), "", EXT_PAR);
        if (openPar(img.openPath.path, 1) == false)  return;
        img.movImageOpened = 1;
        ClearChanged();
        ControlForm->ShowAll();
        imageFormInitialize(1);
        img.clickIgnore = 1;
        if (loadImage() == false)  fractalCalculationStart();
    }
    else  img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::OpenImageClick(TObject *Sender)
{
    char dir[MAXPATH];

    tempStopRequest();
    OpenPictureDialog->Filter = "Image files (*.bmp)|*.BMP";
    OpenPictureDialog->FileName = "";
    strcpy(dir, img.openPath.drive);
    strcat(dir, img.openPath.dir);
    OpenPictureDialog->InitialDir = dir;
    if (OpenPictureDialog->Execute()) {
        stopForOpen();
        img.threadTempStop = 0;
        setOpenPath(OpenPictureDialog->FileName.c_str(), "", EXT_PAR);
        if (openPar(img.openPath.path, 1) == false)  return;
        ClearChanged();
        ControlForm->ShowAll();
        imageFormInitialize(1);
        img.clickIgnore = 1;
        if (loadImage() == false)  fractalCalculationStart();
    }
    else  img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SaveClick(TObject *Sender)
{
    tempStopRequest();
    savePar(0);
    saveImage(0);
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SaveAsClick(TObject *Sender)
{
    char dir[MAXPATH];
    FilePath path;

    tempStopRequest();
    SaveDialog->Filter = "Image files (*.bmp *.jpg)|*.BMP;*.JPG";
    SaveDialog->FileName = "";
    strcpy(dir, img.saveAsPath.drive);
    strcat(dir, img.saveAsPath.dir);
    SaveDialog->InitialDir = dir;
    if (SaveDialog->Execute()) {
        setPath(SaveDialog->FileName.c_str(), "", "", &path);
        if (strcmp((const char *)&path.ext, EXT_BMP) == 0)       img.saveImageExt = Bmp;
        else if (strcmp((const char *)&path.ext, EXT_JPG) == 0)  img.saveImageExt = Jpg;
        ControlForm->ShowSaveImageExt();
        savePar(1);
        saveImage(1);
        img.clickIgnore = 1;
    }
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::OptionClick(TObject *Sender)
{
    tempStopRequest();
    initEdit = init;
    OptionForm->ShowAll(&init);
    OptionForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ExitClick(TObject *Sender)
{
    img.threadTerminate = 1;
    Sleep(50);
    exit(0);
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ShowRootControlClick(TObject *Sender)
{
    ControlForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ReverseAnalysisClick(TObject *Sender)
{
    BodyAndHeadForm->Hide();
    SpiralForm->Hide();
    img.reverseAnalysis = 1;
    img.reverseAnalysisZoom = 0;
    if (ReverseAnalysisForm->ZoomCheckBox->Checked == false)
        changeToBoxMode();
    reverseAnalysisFormInitialize();
    ReverseAnalysisForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::BodyAndHeadClick(TObject *Sender)
{
    ReverseAnalysisForm->Hide();
    SpiralForm->Hide();
    img.reverseAnalysis = 2;
    img.reverseAnalysisZoom = 0;
    img.headNotFound = 0;
    if (BodyAndHeadForm->ZoomCheckBox->Checked == false)
        changeToBoxMode();
    bodyAndHeadFormInitialize();
    BodyAndHeadForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SpiralClick(TObject *Sender)
{
    ReverseAnalysisForm->Hide();
    BodyAndHeadForm->Hide();
    img.reverseAnalysis = 3;
    img.reverseAnalysisZoom = 0;
    img.dotLine = 1;
    img.topNext = 0;
    img.save1Dimension = -1;
    img.save2Dimension = -1;
    if (SpiralForm->ZoomCheckBox->Checked == false)
        changeToBoxMode();
    spiralFormInitialize();
    if (SpiralForm->Visible == false) {
        SpiralForm->Show();
        ImageForm->BringToFront();
    }
    SpiralForm->LineRadioButton->Checked = true;
    SpiralForm->TopRadioButton->Checked  = true;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::LowDimensionClick(TObject *Sender)
{
    tempStopRequest();
    low.fromDimension = 0;
    low.toDimension = 3;
    LowDimensionForm->ShowAll();
    LowDimensionForm->ShowModal();
    if (LowDimensionForm->ModalResult != mrOk) {
        img.threadTempStop = 0;
        return;
    }
    stopForOpen();
    img.threadTempStop = 0;
    low.onDemo = 1;
    low.dimension = low.fromDimension - 1;
    low.nthRoot = (1 << 20);
    ImageForm->changeStaticMenu();
    startLow();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ShowFractalControlClick(TObject *Sender)
{
    ControlForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::IterClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 0;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::RealClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 1;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::RealBClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 2;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ImagClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 3;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ImagBClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 4;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::MultClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 5;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::MultBClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 6;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::DistanceClick(TObject *Sender)
{
    img.fractalCalculationCompleted = 0;
    par.outsideOption = 7;
    ShowOutsideOptionChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ImageSizeClick(TObject *Sender)
{
    ImageSizeForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::FormSizeAutoClick(TObject *Sender)
{
    if (img.formSizeAuto == 0) {
        img.formSizeAuto = 1;
        ImageForm->Image->Left = 0;
        ImageForm->Image->Top  = 0;
        ClientWidth  = par.imageSize[X];
        ClientHeight = par.imageSize[Y];
        ClientWidth  = par.imageSize[X];
        ClientHeight = par.imageSize[Y];
        AutoSize = true;
    }
    else {
        img.formSizeAuto = 0;
        AutoSize = false;
    }
    ShowFormSizeAutoChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ZoomClick(TObject *Sender)
{
    ZoomForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::PassMultiClick(TObject *Sender)
{
    img.passMulti = 1;
    ShowPassMultiChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::Pass1Click(TObject *Sender)
{
    img.passMulti = 0;
    ShowPassMultiChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::LoadColorMapClick(TObject *Sender)
{
    char dir[MAXPATH];
    int save;

    save = img.threadTempStop;
    if (save == 0)  tempStopRequest();
    OpenDialog->Filter = "Map files (*.map)|*.MAP";
    OpenDialog->FileName = "";
    strcpy(dir, img.mapPath.drive);
    strcat(dir, img.mapPath.dir);
    OpenDialog->InitialDir = dir;
    if (OpenDialog->Execute()) {
        img.clickIgnore = 1;
        img.onZoom = 0;
        initDrawRect();
        setLPal(par.lPal, OpenDialog->FileName.c_str());
        setMapPath(OpenDialog->FileName.c_str(), "", "");
        changePalette();
        Image->Picture->Graphic = img.fractalBitmap;
        img.changeRGBIndex = 0;
        editColorFormInitialize();
    }
    img.threadTempStop = save;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::EditColorMapClick(TObject *Sender)
{
    tempStopRequest();
    editColorFormInitialize();
    EditColorForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::WriteColorMapClick(TObject *Sender)
{
    char dir[MAXPATH], file[MAXPATH];
    int  len;
    int  save;

    save = img.threadTempStop;
    if (save == 0)  tempStopRequest();
    SaveDialog->Filter = "Map files (*.map)|*.MAP";
    SaveDialog->FileName = "";
    strcpy(dir, img.mapPath.drive);
    strcat(dir, img.mapPath.dir);
    SaveDialog->InitialDir = dir;
    if (SaveDialog->Execute()) {
        img.clickIgnore = 1;
        strcpy(file, SaveDialog->FileName.c_str());
        len = strlen(file);
        if ((len < 4) || strcmp(file + len - 4, ".map"))
            strcat(file, ".map");
        saveLPal(par.lPal, file);
    }
    img.threadTempStop = save;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ChangeRGBClick(TObject *Sender)
{
    tempStopRequest();
    img.onZoom = 0;
    initDrawRect();
    changeRGB();
    changePalette();
    Image->Picture->Graphic = img.fractalBitmap;
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::Cycling64Click(TObject *Sender)
{
    tempStopRequest();
    img.onZoom = 0;
    initDrawRect();
    colorCycling(64);
    changePalette();
    Image->Picture->Graphic = img.fractalBitmap;
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::Cycling8Click(TObject *Sender)
{
    tempStopRequest();
    img.onZoom = 0;
    initDrawRect();
    colorCycling(8);
    changePalette();
    Image->Picture->Graphic = img.fractalBitmap;
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::Cycling1Click(TObject *Sender)
{
    tempStopRequest();
    img.onZoom = 0;
    initDrawRect();
    colorCycling(1);
    changePalette();
    Image->Picture->Graphic = img.fractalBitmap;
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::CyclingReverseClick(TObject *Sender)
{
    if (img.cyclingReverse == 0)  img.cyclingReverse = 1;
    else                          img.cyclingReverse = 0;
    ShowCyclingReverseChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::CyclingAutoClick(TObject *Sender)
{
    if (img.cyclingAuto == 0) {
        img.onZoom = 0;
        initDrawRect();
        img.cyclingAuto = 1;
        startCyclingAuto();
    }
    else {
        img.cyclingAuto = 0;
        img.threadTerminate = 1;
    }
    ShowCyclingAutoChecked();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ZoomInMovieClick(TObject *Sender)
{
    if (!mov.onMakingMovie)  img.threadTerminate = 1;
    SelfSimilarityMovieForm->Hide();
    ZoomInMovieForm->Hide();
    if (!mov.onMakingMovie)  ZoomInMovieForm->ClearMovieValue();
    else                     ZoomInMovieForm->StartButton->Enabled = true;
    ZoomInMovieForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SelfSimilarityMovieClick(
      TObject *Sender)
{
    if (!mov.onMakingMovie)  img.threadTerminate = 1;
    ZoomInMovieForm->Hide();
    SelfSimilarityMovieForm->Hide();
    if (!mov.onMakingMovie)  SelfSimilarityMovieForm->ClearMovieValue();
    else                     SelfSimilarityMovieForm->StartButton->Enabled = true;
    SelfSimilarityMovieForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::OpenMovieClick(TObject *Sender)
{
    char dir[MAXPATH];

    tempStopRequest();
    OpenDialog->Filter = "Movie files (zmov,smov)|*.ZMOV;*.SMOV";
    OpenDialog->FileName = "";
    strcpy(dir, img.moviePath.drive);
    strcat(dir, img.moviePath.dir);
    OpenDialog->InitialDir = dir;
    if (OpenDialog->Execute()) {
        if (img.onDrawing != Non)  TerminateThread((void *)img.threads->Handle, 0);
        calculationStopped();
        img.threadTempStop = 0;
        setMoviePath(OpenDialog->FileName.c_str(), "", "");
        if (img.movListFp)  fclose(img.movListFp);
        strcpy(img.movListFileName, img.moviePath.file);
        img.movListFp = fopen(img.moviePath.path, "r+b");
        if (img.movListFp == NULL)  return;
        if (getMovieHeader()) {
            ShowMessage("Movie Header Get Error");
            return;
        }
        if (mov.nowSerialNumber == 0) {
            ShowMessage("No Image!");
            return;
        }
        disableSave();
        disableRoot();
        disableFractal();
        disableColor();
        MovieControlForm->StopButton->Enabled = true;
        MovieControlForm->Show();
        ZoomInMovieForm->Hide();
        SelfSimilarityMovieForm->Hide();
        img.movieSkipNoImage = 0;
        startMovie();
    }
    else  img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::MovieControlClick(TObject *Sender)
{
    MovieControlForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ContentsClick(TObject *Sender)
{
    char path[MAXPATH];

    strcpy(path, img.startPath);
    strcat(path, "MandelbrotRootExplorer.hlp");
    Application->HelpFile = path;
    Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::AboutClick(TObject *Sender)
{
    AboutBox->Show();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Shift.Contains(ssCtrl)) {
        zoomFormShowed = 1;
        ZoomForm->Show();
        return;
    }
    if (img.fractalChanged || img.centerChanged || img.rootChanged) {
        ControlForm->StatusAlarm("Parameter Changed.");
        return;
    }
    if (img.onZoom || img.clickIgnore)  return;
    if (img.onDrawing == ReverseShow)  return;
    if ((img.onDrawing != Non) && (img.onDrawing != Fractal)) {
        ControlForm->StatusAlarm("Can't Zoom Now.");
        return;
    }
    if ((img.onDrawing != Non))  tempStopRequest();
    if (img.zoomMode == 0) {
        mouseOnDown = 1;
        mouseDownX = X;
        mouseDownY = Y;
    }
    else {
        if (img.reverseAnalysis && (img.reverseAnalysisZoom == 0)) {
            if (img.reverseAnalysis == 1)       ReverseAnalysisForm->ResultAlarm("Not Box Zoom");
            else if (img.reverseAnalysis == 2)  BodyAndHeadForm->ResultAlarm("Not Box Zoom");
            else if (img.reverseAnalysis == 3)  SpiralForm->ResultAlarm("Not Box Zoom");
            img.threadTempStop = 0;
            return;
        }
        if (img.onDrawing != Non) {
            TerminateThread((void *)img.threads->Handle, 0);
            calculationStopped();
            img.rootChanged = 0;
        }
        if (img.rootFindNonStop) {
            img.rootFindNonStop = 0;
            FindingRootForm->ShowNonStop();
            img.rootChanged = 0;
        }
        img.onZoom = 1;
        img.moveCenter = 1;
        img.zoomCenterX = X;
        img.zoomCenterY = Y;
        img.zoomMag = img.zoomMode;
        if (Button != mbRight)  img.zoomMag = 1.0 / img.zoomMag;
        fractalCalculationStart();
    }
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    int centerX2, centerY2;
    int topX, topY, lastX, lastY;

    if (img.fractalChanged || img.centerChanged || img.rootChanged)  return;
    if (img.clickIgnore || (mouseOnDown == 0))  return;
    if ((img.onDrawing != Non) && (img.onDrawing != Fractal))  return;
    centerX2 = 2 * mouseDownX;
    centerY2 = 2 * mouseDownY;
    calcRect(1, X, Y, centerX2, centerY2, &topX, &topY, &lastX, &lastY);
    if ((topX == lastX) || (topY == lastY))  return;
    if (prevOnShow)  drawRect(prevTopX, prevTopY, prevLastX, prevLastY);
    drawRect(topX, topY, lastX, lastY);
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int centerX2, centerY2;
    int topX, topY, lastX, lastY;

    if (zoomFormShowed) {
        zoomFormShowed = 0;
        return;
    }
    if (img.fractalChanged || img.centerChanged || img.rootChanged)  return;
    if (img.clickIgnore) {
        img.clickIgnore = 0;
        return;
    }
    if ((img.onDrawing != Non) && (img.onDrawing != Fractal))  return;
    if (img.zoomMode)  return;
    mouseOnDown = 0;
    if (img.onZoom) {
        if (((X > prevTopX) && (X < prevLastX)) && ((Y > prevTopY) && (Y < prevLastY))) {
            if (img.reverseAnalysis && (par.formula != Mandelbrot)) {
                if (img.reverseAnalysis == 1)       ReverseAnalysisForm->ResultAlarm("Not Mandelbrot");
                else if (img.reverseAnalysis == 2)  BodyAndHeadForm->ResultAlarm("Not Mandelbrot");
                else if (img.reverseAnalysis == 3)  SpiralForm->ResultAlarm("Not Mandelbrot");
                img.onZoom = 0;
                drawRect(prevTopX, prevTopY, prevLastX, prevLastY);
                img.threadTempStop = 0;
                return;
            }
            if (img.onDrawing != Non) {
                TerminateThread((void *)img.threads->Handle, 0);
                calculationStopped();
                img.rootChanged = 0;
            }
            if (img.rootFindNonStop) {
                img.rootFindNonStop = 0;
                FindingRootForm->ShowNonStop();
                img.rootChanged = 0;
            }
            img.zoomMag = (PRECISION)abs(prevLastX - prevTopX) / (PRECISION)(par.imageSize[0] - 1);
            if ((Button == mbRight) && ((img.reverseAnalysis == 0) || img.reverseAnalysisZoom))  img.zoomMag = 1.0 / img.zoomMag;
            fractalCalculationStart();
        }
        else {
            img.onZoom = 0;
            drawRect(prevTopX, prevTopY, prevLastX, prevLastY);
            img.threadTempStop = 0;
        }
        return;
    }
    if ((abs(mouseDownX - X) < 2) && (abs(mouseDownY - Y) < 2)) {
        img.moveCenter = 0;
        centerX2 = par.imageSize[0] - 1;
        centerY2 = par.imageSize[1] - 1;
    }
    else {
        img.moveCenter = 1;
        centerX2 = 2 * mouseDownX;
        centerY2 = 2 * mouseDownY;
        img.zoomCenterX = mouseDownX;
        img.zoomCenterY = mouseDownY;
    }
    calcRect(img.moveCenter, X, Y, centerX2, centerY2, &topX, &topY, &lastX, &lastY);
    if ((topX == lastX) || (topY == lastY))  return;
    if (prevOnShow)  drawRect(prevTopX, prevTopY, prevLastX, prevLastY);
    drawRect(topX, topY, lastX, lastY);
    img.onZoom = 1;
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::FractalOnPaintMessage(TMessage &Message)
{
    fractalShow(Message.WParam);
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::FractalCalcEndMessage(TMessage &Message)
{
    fractalCalculationEnd();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::CyclingPaintMessage(TMessage &Message)
{
    cyclingPaint();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::MoviePaintMessage(TMessage &Message)
{
    moviePaint(Message.WParam);
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::ReversePaintMessage(TMessage &Message)
{
    reverseShow();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SpiralPaintMessage(TMessage &Message)
{
    spiralShow(Message.WParam);
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SpiralRetryMessage(TMessage &Message)
{
    spiralRetry();
}
//---------------------------------------------------------------------------
void __fastcall TImageForm::SpiralEndMessage(TMessage &Message)
{
    if (img.spiralStopReason == 3) {
        calculationStopped();
        return;
    }
    img.onDrawing = Non;
    spiralEndMessage();
    if (demo.onDemo) {
        Sleep(1000);
        startDemo();
    }
}
//---------------------------------------------------------------------------
void TImageForm::ShowOutsideOptionChecked()
{
    Iter->Checked     = false;
    Real->Checked     = false;
    RealB->Checked    = false;
    Imag->Checked     = false;
    ImagB->Checked    = false;
    Mult->Checked     = false;
    MultB->Checked    = false;
    Distance->Checked = false;
    if (par.outsideOption == 0)       Iter->Checked     = true;
    else if (par.outsideOption == 1)  Real->Checked     = true;
    else if (par.outsideOption == 2)  RealB->Checked    = true;
    else if (par.outsideOption == 3)  Imag->Checked     = true;
    else if (par.outsideOption == 4)  ImagB->Checked    = true;
    else if (par.outsideOption == 5)  Mult->Checked     = true;
    else if (par.outsideOption == 6)  MultB->Checked    = true;
    else if (par.outsideOption == 7)  Distance->Checked = true;
}
//---------------------------------------------------------------------------
void TImageForm::ShowFormSizeAutoChecked()
{
    if (img.formSizeAuto == 0)  FormSizeAuto->Checked = false;
    else                        FormSizeAuto->Checked = true;
}
//---------------------------------------------------------------------------
void TImageForm::ShowPassMultiChecked()
{
    if (img.passMulti == 0) {
        Pass1->Checked     = true;
        PassMulti->Checked = false;
    }
    else {
        Pass1->Checked     = false;
        PassMulti->Checked = true;
    }
}
//---------------------------------------------------------------------------
void TImageForm::ShowCyclingReverseChecked()
{
    if (img.cyclingReverse == 0)  CyclingReverse->Checked = false;
    else                          CyclingReverse->Checked = true;
}
//---------------------------------------------------------------------------
void TImageForm::ShowCyclingAutoChecked()
{
    if (img.cyclingAuto == 0)  CyclingAuto->Checked = false;
    else                       CyclingAuto->Checked = true;
}
//---------------------------------------------------------------------------
void TImageForm::ShowAll()
{
    ShowOutsideOptionChecked();
    ShowPassMultiChecked();
    ShowFormSizeAutoChecked();
    ShowCyclingReverseChecked();
    ShowCyclingAutoChecked();
}
//---------------------------------------------------------------------------
void TImageForm::calcRect(int mode, int X, int Y, int centerX2, int centerY2, int *topX, int *topY, int *lastX, int *lastY)
{
    int spanX2, spanY2;

    spanX2 = abs(centerX2 - 2 * X);
    spanY2 = abs(centerY2 - 2 * Y);
    if (spanX2 * par.imageSize[1] > spanY2 * par.imageSize[0]) {
        if (2 * X <= centerX2) {
            *topX  = X;
            *lastX = centerX2 - *topX;
        }
        else {
            *lastX = X;
            *topX  = centerX2 - *lastX;
        }
        if (mode == 0)
            *topY  = *topX * par.imageSize[1] / par.imageSize[0];
        else
            *topY  = (mouseDownX - *topX) * par.imageSize[1] / par.imageSize[0] + mouseDownY;
        *lastY = centerY2 - *topY;
    }
    else {
        if (2 * Y <= centerY2) {
            *topY  = Y;
            *lastY = centerY2 - *topY;
        }
        else {
            *lastY = Y;
            *topY  = centerY2 - *lastY;
        }
        if (mode == 0)
            *topX  = *topY * par.imageSize[0] / par.imageSize[1];
        else
            *topX  = (mouseDownY - *topY) * par.imageSize[0] / par.imageSize[1] + mouseDownX;
        *lastX = centerX2 - *topX;
    }
}
//---------------------------------------------------------------------------
void TImageForm::drawRect(int topX, int topY, int lastX, int lastY)
{
    TPoint point[5];
    int save;

    if (topX > lastX) {
        save = topX;
        topX = lastX;
        lastX = save;
    }
    if (topY > lastY) {
        save = topY;
        topY = lastY;
        lastY = save;
    }
    point[0] = TPoint(topX, topY);
    point[1] = TPoint(topX, lastY);
    point[2] = TPoint(lastX, lastY);
    point[3] = TPoint(lastX, topY);
    point[4] = TPoint(topX, topY);
    Image->Canvas->Pen->Color = clWhite;
    Image->Canvas->Pen->Width = 1;
    Image->Canvas->Pen->Style = psSolid;
    Image->Canvas->Pen->Mode  = pmXor;
    Image->Canvas->Polyline(point, 5);
    prevTopX  = topX;
    prevTopY  = topY;
    prevLastX = lastX;
    prevLastY = lastY;
    if (prevOnShow == 0)  prevOnShow = 1;
    else                  prevOnShow = 0;
}
//---------------------------------------------------------------------------
void TImageForm::initDrawRect()
{
    if (prevOnShow)  drawRect(prevTopX, prevTopY, prevLastX, prevLastY);
    prevOnShow = 0;
    mouseOnDown = 0;
}
//---------------------------------------------------------------------------
void TImageForm::tempStopRequest()
{
    EditColorForm->Hide();
    img.threadTempStop = 1;
    if ((img.onDrawing == ColorCycling) || (img.onDrawing == SlideShow)) {
        img.onTempStop = 0;
        while (img.onTempStop == 0)  Sleep(5);
    }
}
//---------------------------------------------------------------------------
void TImageForm::stopForOpen()
{
    if (img.onDrawing == SlideShow)        endMovie();
    else if (img.onDrawing == SpiralShow)  spiralStop();
    else                                   RootChangedStop();
}
//---------------------------------------------------------------------------
void TImageForm::changeSaveMenu()
{
    if (img.fractalChanged || img.rootChanged || img.centerChanged || par.nthRootAtRandom)
        disableSave();
    else
        enableSave();
}
//---------------------------------------------------------------------------
void TImageForm::changeStaticMenu()
{
    if (img.onDrawing || demo.onDemo || low.onDemo)  disableCyclingAuto();
    else                                             enableCyclingAuto();
}
//---------------------------------------------------------------------------
void TImageForm::disableSave()
{
    Save->Enabled   = false;
    SaveAs->Enabled = false;
}
//---------------------------------------------------------------------------
void TImageForm::disableRoot()
{
    ShowRootControl->Enabled = false;
    ReverseAnalysis->Enabled = false;
    Study->Enabled           = false;
    ControlForm->Hide();
    ReverseAnalysisForm->Hide();
    BodyAndHeadForm->Hide();
    SpiralForm->Hide();
}
//---------------------------------------------------------------------------
void TImageForm::disableFractal()
{
    ShowFractalControl->Enabled = false;
    Outside->Enabled   = false;
    ImageSize->Enabled = false;
    Zoom->Enabled      = false;
    Pass->Enabled      = false;
    ControlForm->Hide();
    ImageSizeForm->Hide();
}
//---------------------------------------------------------------------------
void TImageForm::disableOutside()
{
    Outside->Enabled = false;
}
//---------------------------------------------------------------------------
void TImageForm::disableColor()
{
    Color->Enabled = false;
    EditColorForm->Hide();
}
//---------------------------------------------------------------------------
void TImageForm::disableCyclingAuto()
{
    CyclingAuto->Enabled = false;
}
//---------------------------------------------------------------------------
void TImageForm::disableMakeZoomInMovie()
{
    ZoomInMovie->Enabled = false;
}
//---------------------------------------------------------------------------
void TImageForm::disableMakeSelfSimilarityMovie()
{
    SelfSimilarityMovie->Enabled = false;
}
//---------------------------------------------------------------------------
void TImageForm::enableSave()
{
    Save->Enabled   = true;
    SaveAs->Enabled = true;
}
//---------------------------------------------------------------------------
void TImageForm::enableRoot()
{
    ShowRootControl->Enabled = true;
    ReverseAnalysis->Enabled = true;
    Study->Enabled           = true;
    ControlForm->Show();
}
//---------------------------------------------------------------------------
void TImageForm::enableFractal()
{
    ShowFractalControl->Enabled = true;
    Outside->Enabled   = true;
    ImageSize->Enabled = true;
    Zoom->Enabled      = true;
    Pass->Enabled      = true;
    ControlForm->Show();
}
//---------------------------------------------------------------------------
void TImageForm::enableOutside()
{
    Outside->Enabled = true;
}
//---------------------------------------------------------------------------
void TImageForm::enableColor()
{
    Color->Enabled = true;
}
//---------------------------------------------------------------------------
void TImageForm::enableCyclingAuto()
{
    CyclingAuto->Enabled = true;
}
//---------------------------------------------------------------------------
void TImageForm::enableMakeZoomInMovie()
{
    ZoomInMovie->Enabled = true;
}
//---------------------------------------------------------------------------
void TImageForm::enableMakeSelfSimilarityMovie()
{
    SelfSimilarityMovie->Enabled = true;
}
//---------------------------------------------------------------------------

