//---------------------------------------------------------------------------
#ifndef ImageH
#define ImageH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>

#define WM_FRACTAL_ON_PAINT     (WM_APP + 3)
#define WM_FRACTAL_CALC_END     (WM_APP + 4)
#define WM_CYCLING_PAINT        (WM_APP + 5)
#define WM_MOVIE_PAINT          (WM_APP + 6)
#define WM_REVERSE_PAINT        (WM_APP + 7)
#define WM_SPIRAL_PAINT         (WM_APP + 8)
#define WM_SPIRAL_RETRY         (WM_APP + 9)
#define WM_SPIRAL_END           (WM_APP + 10)
//---------------------------------------------------------------------------
class TImageForm : public TForm
{
__published:
    TMainMenu *MainMenu;
    TImage *Image;

    TMenuItem *File;
    TMenuItem *OpenDemo;
    TMenuItem *Open;
    TMenuItem *OpenImage;
    TMenuItem *Save;
    TMenuItem *SaveAs;
    TMenuItem *N00;
    TMenuItem *Option;
    TMenuItem *N01;
    TMenuItem *Exit;

    TMenuItem *Root;
    TMenuItem *ShowRootControl;
    TMenuItem *N10;
    TMenuItem *ReverseAnalysis;
    TMenuItem *Study;
    TMenuItem *BodyAndHead;
    TMenuItem *Spiral;
    TMenuItem *N11;
    TMenuItem *LowDimension;

    TMenuItem *FractalM;
    TMenuItem *ShowFractalControl;
    TMenuItem *N20;
    TMenuItem *Inside;
    TMenuItem *Outside;
    TMenuItem *Iter;
    TMenuItem *Real;
    TMenuItem *RealB;
    TMenuItem *Imag;
    TMenuItem *ImagB;
    TMenuItem *Mult;
    TMenuItem *MultB;
    TMenuItem *Distance;
    TMenuItem *N21;
    TMenuItem *ImageSize;
    TMenuItem *FormSizeAuto;
    TMenuItem *N22;
    TMenuItem *Zoom;
    TMenuItem *N23;
    TMenuItem *Pass;
    TMenuItem *PassMulti;
    TMenuItem *Pass1;

    TMenuItem *Color;
    TMenuItem *LoadColorMap;
    TMenuItem *EditColorMap;
    TMenuItem *WriteColorMap;
    TMenuItem *N30;
    TMenuItem *ChangeRGB;
    TMenuItem *Cycling;
    TMenuItem *Cycling64;
    TMenuItem *Cycling8;
    TMenuItem *Cycling1;
    TMenuItem *CyclingReverse;
    TMenuItem *N31;
    TMenuItem *CyclingAuto;

    TMenuItem *Movie;
    TMenuItem *ZoomInMovie;
    TMenuItem *SelfSimilarityMovie;
    TMenuItem *N40;
    TMenuItem *OpenMovie;
    TMenuItem *MovieControl;

    TMenuItem *Help;
    TMenuItem *Contents;
    TMenuItem *About;

    TOpenDialog *OpenDialog;
    TOpenPictureDialog *OpenPictureDialog;
    TSaveDialog *SaveDialog;

    void __fastcall FormResize(TObject *Sender);

    void __fastcall OpenDemoClick(TObject *Sender);
    void __fastcall OpenClick(TObject *Sender);
    void __fastcall OpenImageClick(TObject *Sender);
    void __fastcall SaveClick(TObject *Sender);
    void __fastcall SaveAsClick(TObject *Sender);
    void __fastcall OptionClick(TObject *Sender);
    void __fastcall ExitClick(TObject *Sender);

    void __fastcall ShowRootControlClick(TObject *Sender);
    void __fastcall ReverseAnalysisClick(TObject *Sender);
    void __fastcall BodyAndHeadClick(TObject *Sender);
    void __fastcall SpiralClick(TObject *Sender);
    void __fastcall LowDimensionClick(TObject *Sender);

    void __fastcall ShowFractalControlClick(TObject *Sender);
    void __fastcall IterClick(TObject *Sender);
    void __fastcall RealClick(TObject *Sender);
    void __fastcall RealBClick(TObject *Sender);
    void __fastcall ImagClick(TObject *Sender);
    void __fastcall ImagBClick(TObject *Sender);
    void __fastcall MultClick(TObject *Sender);
    void __fastcall MultBClick(TObject *Sender);
    void __fastcall DistanceClick(TObject *Sender);
    void __fastcall ImageSizeClick(TObject *Sender);
    void __fastcall FormSizeAutoClick(TObject *Sender);
    void __fastcall ZoomClick(TObject *Sender);
    void __fastcall PassMultiClick(TObject *Sender);
    void __fastcall Pass1Click(TObject *Sender);

    void __fastcall LoadColorMapClick(TObject *Sender);
    void __fastcall EditColorMapClick(TObject *Sender);
    void __fastcall WriteColorMapClick(TObject *Sender);
    void __fastcall ChangeRGBClick(TObject *Sender);
    void __fastcall Cycling64Click(TObject *Sender);
    void __fastcall Cycling8Click(TObject *Sender);
    void __fastcall Cycling1Click(TObject *Sender);
    void __fastcall CyclingReverseClick(TObject *Sender);
    void __fastcall CyclingAutoClick(TObject *Sender);

    void __fastcall ZoomInMovieClick(TObject *Sender);
    void __fastcall SelfSimilarityMovieClick(TObject *Sender);
    void __fastcall OpenMovieClick(TObject *Sender);
    void __fastcall MovieControlClick(TObject *Sender);

    void __fastcall ContentsClick(TObject *Sender);
    void __fastcall AboutClick(TObject *Sender);

    void __fastcall ImageMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
    void __fastcall ImageMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
private:
    int mouseOnDown;
    int mouseDownX;
    int mouseDownY;
    int prevTopX;
    int prevTopY;
    int prevLastX;
    int prevLastY;
    int prevOnShow;
    int zoomFormShowed;
public:
    __fastcall TImageForm(TComponent* Owner);
    void ShowOutsideOptionChecked();
    void ShowFormSizeAutoChecked();
    void ShowPassMultiChecked();
    void ShowCyclingReverseChecked();
    void ShowCyclingAutoChecked();
    void ShowAll();
    void calcRect(int mode, int X, int Y, int centerX2, int centerY2, int *topX, int *topY, int *lastX, int *lastY);
    void drawRect(int topX, int topY, int lastX, int lastY);
    void initDrawRect();
    void tempStopRequest();
    void stopForOpen();
    void changeSaveMenu();
    void changeStaticMenu();
    void disableSave();
    void disableRoot();
    void disableFractal();
    void disableOutside();
    void disableColor();
    void disableCyclingAuto();
    void disableMakeZoomInMovie();
    void disableMakeSelfSimilarityMovie();
    void enableSave();
    void enableRoot();
    void enableFractal();
    void enableOutside();
    void enableColor();
    void enableCyclingAuto();
    void enableMakeZoomInMovie();
    void enableMakeSelfSimilarityMovie();
protected:
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_FRACTAL_ON_PAINT, TMessage, FractalOnPaintMessage)
        MESSAGE_HANDLER(WM_FRACTAL_CALC_END, TMessage, FractalCalcEndMessage)
        MESSAGE_HANDLER(WM_CYCLING_PAINT,    TMessage, CyclingPaintMessage)
        MESSAGE_HANDLER(WM_MOVIE_PAINT,      TMessage, MoviePaintMessage)
        MESSAGE_HANDLER(WM_REVERSE_PAINT,    TMessage, ReversePaintMessage)
        MESSAGE_HANDLER(WM_SPIRAL_PAINT,     TMessage, SpiralPaintMessage)
        MESSAGE_HANDLER(WM_SPIRAL_RETRY,     TMessage, SpiralRetryMessage)
        MESSAGE_HANDLER(WM_SPIRAL_END,       TMessage, SpiralEndMessage)
    END_MESSAGE_MAP(TForm)
    void __fastcall FractalOnPaintMessage(TMessage &Message);
    void __fastcall FractalCalcEndMessage(TMessage &Message);
    void __fastcall CyclingPaintMessage(TMessage &Message);
    void __fastcall MoviePaintMessage(TMessage &Message);
    void __fastcall ReversePaintMessage(TMessage &Message);
    void __fastcall SpiralPaintMessage(TMessage &Message);
    void __fastcall SpiralRetryMessage(TMessage &Message);
    void __fastcall SpiralEndMessage(TMessage &Message);
};
//---------------------------------------------------------------------------
extern PACKAGE TImageForm *ImageForm;
//---------------------------------------------------------------------------
#endif
