//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "LowDimension.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLowDimensionForm *LowDimensionForm;
//---------------------------------------------------------------------------
__fastcall TLowDimensionForm::TLowDimensionForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::FormPaint(TObject *Sender)
{
    ShowAll();
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::FromDimensionEditExit(TObject *Sender)
{
    SetFromDimension();
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::FromDimensionEditKeyPress(
      TObject *Sender, char &Key)
{
    if (Key == '\r')  SetFromDimension();
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::ToDimensionEditExit(TObject *Sender)
{
    SetToDimension();
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::ToDimensionEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetToDimension();
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::OKButtonClick(TObject *Sender)
{
    if (low.toDimension < low.fromDimension) {
        ShowMessage("From-To inverse");
        low.toDimension = low.fromDimension;
        ShowAll();
        return;
    }
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TLowDimensionForm::CancelButtonClick(TObject *Sender)
{
    ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void TLowDimensionForm::SetFromDimension()
{
    int dimension;

    try {
        dimension = StrToInt(FromDimensionEdit->Text);
        if ((dimension < 0) || (dimension > 16)) {
            ShowMessage("Invalid number specified");
            if (dimension < 0)  dimension = 0;
            else                dimension = 16;
        }
        low.fromDimension = dimension;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowFromDimension();
}
//---------------------------------------------------------------------------
void TLowDimensionForm::SetToDimension()
{
    int dimension;

    try {
        dimension = StrToInt(ToDimensionEdit->Text);
        if ((dimension < 0) || (dimension > 16)) {
            ShowMessage("Invalid number specified");
            if (dimension < 0)  dimension = 0;
            else                dimension = 16;
        }
        low.toDimension = dimension;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowToDimension();
}
//---------------------------------------------------------------------------
void TLowDimensionForm::ShowFromDimension()
{
    char buf[32];

    sprintf(buf, "%d", low.fromDimension);
    FromDimensionEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TLowDimensionForm::ShowToDimension()
{
    char buf[32];

    sprintf(buf, "%d", low.toDimension);
    ToDimensionEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TLowDimensionForm::ShowAll()
{
    ShowFromDimension();
    ShowToDimension();
}
//---------------------------------------------------------------------------

