//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "MovieControl.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMovieControlForm *MovieControlForm;
//---------------------------------------------------------------------------
__fastcall TMovieControlForm::TMovieControlForm(TComponent* Owner)
    : TForm(Owner)
{
    Top = 15;
    Left = 8;
}
//---------------------------------------------------------------------------
void __fastcall TMovieControlForm::ReverseCheckBoxClick(TObject *Sender)
{
    SetMovieReverse();
}
//---------------------------------------------------------------------------
void __fastcall TMovieControlForm::DelayEditExit(TObject *Sender)
{
    SetMovieDelay();
}
//---------------------------------------------------------------------------
void __fastcall TMovieControlForm::DelayEditKeyPress(TObject *Sender,
      char &Key)
{
    if (Key == '\r')  SetMovieDelay();
}
//---------------------------------------------------------------------------
void __fastcall TMovieControlForm::StopButtonClick(TObject *Sender)
{
    if (img.onDrawing != Non)  img.threadTerminate = 1;
}
//---------------------------------------------------------------------------
void __fastcall TMovieControlForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void TMovieControlForm::SetMovieReverse()
{
    if (ReverseCheckBox->Checked == true)  img.movieReverse = 1;
    else                                   img.movieReverse = 0;
}
//---------------------------------------------------------------------------
void TMovieControlForm::SetMovieDelay()
{
    int delay;

    try {
        delay = StrToInt(DelayEdit->Text);
        if (delay < 0) {
            ShowMessage("Invalid number specified");
            delay = 0;
        }
        img.movieDelay = delay;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowMovieDelay();
}
//---------------------------------------------------------------------------
void TMovieControlForm::ShowMovieReverse()
{
    if (img.movieReverse)  ReverseCheckBox->Checked = true;
    else                   ReverseCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TMovieControlForm::ShowMovieDelay()
{
    char buf[32];

    sprintf(buf, "%d", img.movieDelay);
    DelayEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TMovieControlForm::ShowAll()
{
    ShowMovieReverse();
    ShowMovieDelay();
}
//---------------------------------------------------------------------------

