//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Option.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptionForm *OptionForm;
//---------------------------------------------------------------------------
__fastcall TOptionForm::TOptionForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::FormHide(TObject *Sender)
{
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::WithDemoButtonClick(TObject *Sender)
{
    char dir[MAXPATH];

    ImageForm->OpenDialog->Filter = "Demo files (*.demo)|*.DEMO";
    ImageForm->OpenDialog->FileName = "";
    strcpy(dir, img.demoPath.drive);
    strcat(dir, img.demoPath.dir);
    ImageForm->OpenDialog->InitialDir = dir;
    if (ImageForm->OpenDialog->Execute()) {
        setDemoPath(ImageForm->OpenDialog->FileName.c_str(), "", "");
        strcpy(initEdit.demoPath, img.demoPath.file);
        img.clickIgnore = 1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::WithoutDemoButtonClick(TObject *Sender)
{
    initEdit.demoPath[0] = 0;
    ShowMessage("Cleared");
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::FitToScreenCheckBoxClick(TObject *Sender)
{
    if (FitToScreenCheckBox->Checked)  initEdit.fitToScreen = 1;
    else                               initEdit.fitToScreen = 0;
    ShowFitToScreen(&initEdit);
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::S0RadioButtonClick(TObject *Sender)
{
    SetSizeDefault(0);
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::S1RadioButtonClick(TObject *Sender)
{
    SetSizeDefault(1);
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::S2RadioButtonClick(TObject *Sender)
{
    SetSizeDefault(2);
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::S3RadioButtonClick(TObject *Sender)
{
    SetSizeDefault(3);
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::ZoomAutoChangeCheckBoxClick(TObject *Sender)
{
    if (ZoomAutoChangeCheckBox->Checked)  initEdit.zoomAutoChange = 1;
    else                                  initEdit.zoomAutoChange = 0;
    ShowZoomAutoChange(&initEdit);
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::ZoomBoxRadioButtonClick(TObject *Sender)
{
    initEdit.zoomModeDefault = 0;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::ZoomClickx8RadioButtonClick(TObject *Sender)
{
    initEdit.zoomModeDefault = 8;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::ZoomClickx4RadioButtonClick(TObject *Sender)
{
    initEdit.zoomModeDefault = 4;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::ZoomClickx2RadioButtonClick(TObject *Sender)
{
    initEdit.zoomModeDefault = 2;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::PMultiRadioButtonClick(TObject *Sender)
{
    initEdit.passMultiDefault = 1;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::P1RadioButtonClick(TObject *Sender)
{
    initEdit.passMultiDefault = 0;
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::SaveButtonClick(TObject *Sender)
{
    init = initEdit;
    PutInitial();
    Hide();
}
//---------------------------------------------------------------------------
void __fastcall TOptionForm::CancelButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void TOptionForm::SetSizeDefault(int button)
{
    int sizeXY[4][2] = { {480, 360}, {640, 480},
                         {800, 600}, {1024, 768} };

    initEdit.sizeDefault[X] = sizeXY[button][X];
    initEdit.sizeDefault[Y] = sizeXY[button][Y];
    FitToScreenCheckBox->Checked = false;
}
//---------------------------------------------------------------------------
void TOptionForm::ShowFitToScreen(Initial *init)
{
    if (init->fitToScreen) {
        FitToScreenCheckBox->Checked = true;
        GetFitToScreenSize(init);
        S0RadioButton->Checked = false;
        S1RadioButton->Checked = false;
        S2RadioButton->Checked = false;
        S3RadioButton->Checked = false;
    }
    else {
        FitToScreenCheckBox->Checked = false;
        if (init->sizeDefault[X] == 480)        S0RadioButton->Checked = true;
        else if (init->sizeDefault[X] == 640)   S1RadioButton->Checked = true;
        else if (init->sizeDefault[X] == 800)   S2RadioButton->Checked = true;
        else if (init->sizeDefault[X] == 1024)  S3RadioButton->Checked = true;
    }
}
//---------------------------------------------------------------------------
void TOptionForm::ShowZoomAutoChange(Initial *init)
{
    if (init->zoomAutoChange) {
        ZoomAutoChangeCheckBox->Checked = true;
        ZoomAutoChangeLabel1->Enabled = true;
        ZoomAutoChangeLabel2->Enabled = true;
    }
    else {
        ZoomAutoChangeCheckBox->Checked = false;
        ZoomAutoChangeLabel1->Enabled = false;
        ZoomAutoChangeLabel2->Enabled = false;
    }
}
//---------------------------------------------------------------------------
void TOptionForm::ShowZoomModeDefault(Initial *init)
{
    if (init->zoomModeDefault == 0)       ZoomBoxRadioButton->Checked     = true;
    else if (init->zoomModeDefault == 8)  ZoomClickx8RadioButton->Checked = true;
    else if (init->zoomModeDefault == 4)  ZoomClickx4RadioButton->Checked = true;
    else if (init->zoomModeDefault == 2)  ZoomClickx2RadioButton->Checked = true;
}
//---------------------------------------------------------------------------
void TOptionForm::ShowPassMultiDefault(Initial *init)
{
    if (init->passMultiDefault)  PMultiRadioButton->Checked = true;
    else                         P1RadioButton->Checked     = true;
}
//---------------------------------------------------------------------------
void TOptionForm::ShowAll(Initial *init)
{
    ShowFitToScreen(init);
    ShowZoomAutoChange(init);
    ShowZoomModeDefault(init);
    ShowPassMultiDefault(init);
}
//---------------------------------------------------------------------------
bool TOptionForm::SetDefaultOption()
{
    init.demoPath[0] = 0;
    init.fitToScreen = 1;
    GetFitToScreenSize(&init);
    init.zoomAutoChange   = 0;
    init.zoomModeDefault  = 0;
    init.passMultiDefault = 1;
    return(PutInitial());
}
//---------------------------------------------------------------------------
void TOptionForm::GetFitToScreenSize(Initial *init)
{
    if (Screen->Width > 1200) {
        init->sizeDefault[X] = DEFAULT_IMAGE_SIZE_X;
        init->sizeDefault[Y] = DEFAULT_IMAGE_SIZE_Y;
    }
    else if (Screen->Width > 1000) {
        init->sizeDefault[X] = 640;
        init->sizeDefault[Y] = 480;
    }
    else {
        init->sizeDefault[X] = 320;
        init->sizeDefault[Y] = 240;
    }
}
//---------------------------------------------------------------------------
bool TOptionForm::GetInitial()
{
    FILE *fp;
    char path[MAXPATH];

    strcpy(path, img.startPath);
    strcat(path, INITIAL_FILE);
    if ((fp = fopen(path, "rb")) == NULL)  return false;
    if (fread(&init, sizeof(init), 1, fp) == 0) {
        fclose(fp);
        return false;
    }
    fclose(fp);
    return true;
}
//---------------------------------------------------------------------------
bool TOptionForm::PutInitial()
{
    FILE *fp;
    char path[MAXPATH];

    strcpy(path, img.startPath);
    strcat(path, INITIAL_FILE);
    if ((fp = fopen(path, "wb")) == NULL)  return false;
    if (fwrite(&init, sizeof(init), 1, fp) == 0) {
        fclose(fp);
        return false;
    }
    fclose(fp);
    return true;
}
//---------------------------------------------------------------------------

