//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "ImageSize.h"
#include "SelfSimilarityMovie.h"
#include "MovieList.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSelfSimilarityMovieForm *SelfSimilarityMovieForm;
//---------------------------------------------------------------------------
__fastcall TSelfSimilarityMovieForm::TSelfSimilarityMovieForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::FormHide(TObject *Sender)
{
    StartButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::TopImageButtonClick(TObject *Sender)
{
    ImageForm->OpenClick(this);
    if (img.movImageOpened == 0)  return;
    if ((par.imageSize[X] > 1024) || (par.imageSize[Y] > 768)) {
        ShowMessage("Too large. Max is 1024x768.");
        return;
    }
    mov.par0Set = 1;
    mov.par0 = par;
    if (mov.par1Set) {
        if (SetInitialMovieValue()) mov.par0Set = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::NextImageButtonClick(TObject *Sender)
{
    ImageForm->OpenClick(this);
    if (img.movImageOpened == 0)  return;
    mov.par1Set = 1;
    mov.par1 = par;
    if (mov.par0Set) {
        if (SetInitialMovieValue()) mov.par1Set = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::FileNameEditExit(TObject *Sender)
{
    SetFileName();
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::FileNameEditKeyPress(TObject *Sender, char &Key)
{
    if (Key == '\r')  SetFileName();
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::NumberOfImagesEditExit(TObject *Sender)
{
    SetNumberOfImages();
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::NumberOfImagesEditKeyPress(TObject *Sender, char &Key)
{
    if (Key == '\r')  SetNumberOfImages();
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::ListButtonClick(TObject *Sender)
{
    char dir[MAXPATH];

    if ((mov.par0Set == 0) || (mov.par1Set == 0)) {
        ImageForm->OpenDialog->Filter = "Movie files (*.smov)|*.SMOV";
        ImageForm->OpenDialog->FileName = "";
        strcpy(dir, img.moviePath.drive);
        strcat(dir, img.moviePath.dir);
        ImageForm->OpenDialog->InitialDir = dir;
        if (ImageForm->OpenDialog->Execute()) {
            setMoviePath(ImageForm->OpenDialog->FileName.c_str(), "", EXT_SMOV);
            if (img.movListFp)  fclose(img.movListFp);
            strcpy(img.movListFileName, img.moviePath.file);
            img.movListFp = fopen(img.moviePath.path, "r+b");
            if (img.movListFp == NULL)  return;
            if (getMovieList()) {
                ShowMessage("List Get Error");
                return;
            }
            TopImageButton->Enabled  = false;
            NextImageButton->Enabled = false;
            FileNameEdit->Enabled       = false;
            NumberOfImagesEdit->Enabled = false;
            if (mov.nowSerialNumber < mov.numberOfImages)
                StartButton->Enabled = true;
            ListButton->Enabled  = true;
            mov.onMakingMovie = 0;
            ShowAll();
        }
        else  return;
    }
    MovieListForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::StartButtonClick(TObject *Sender)
{
    if (mov.onMakingMovie == 0) {
        ImageForm->disableSave();
        ImageForm->disableOutside();
        ImageForm->disableColor();
        ImageForm->disableMakeZoomInMovie();
        ResetButton->Enabled         = false;
        FileNameEdit->Enabled        = false;
        NumberOfImagesEdit->Enabled  = false;
        StartButton->Caption = "Stop";
        par = mov.par0;
        ImageSizeForm->ShowAll();
        imageFormInitialize(1);
        startMakeMovie();
    }
    else  img.threadTerminate = 1;
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::ResetButtonClick(TObject *Sender)
{
    ImageForm->SelfSimilarityMovieClick(ImageForm);
}
//---------------------------------------------------------------------------
void __fastcall TSelfSimilarityMovieForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void TSelfSimilarityMovieForm::SetFileName()
{
    if (!mov.par0Set || !mov.par1Set)  return;
    if (strcmp(img.movListFileName, FileNameEdit->Text.c_str()) == 0)  return;
    if (StartButton->Enabled && img.movListFp) {
        fclose(img.movListFp);
        remove(img.moviePath.path);
    }
    strcpy(img.movListFileName, FileNameEdit->Text.c_str());
    setMoviePath("", img.movListFileName, EXT_SMOV);
    if (img.movListFileName[0] == 0) {
        StartButton->Enabled = false;
        ListButton->Enabled  = false;
        return;
    }
    if (openMovieList()) {
        img.movListFileName[0] = 0;
        FileNameEdit->Text = "";
        StartButton->Enabled = false;
        ListButton->Enabled  = false;
        return;
    }
    TopImageButton->Enabled  = false;
    NextImageButton->Enabled = false;
    if (putMovieList()) {
        ShowMessage("List Put Error");
        return;
    }
    StartButton->Enabled = true;
    ListButton->Enabled  = true;
}
//---------------------------------------------------------------------------
void TSelfSimilarityMovieForm::SetNumberOfImages()
{
    int numberOfImages;

    if (!mov.par0Set || !mov.par1Set)  return;
    try {
        numberOfImages = StrToInt(NumberOfImagesEdit->Text);
        if (mov.numberOfImages == numberOfImages)  return;
        if (numberOfImages < 2) {
            ShowMessage("Invalid number specified");
            numberOfImages = 2;
        }
        if (numberOfImages > 10000) {
            ShowMessage("Invalid number specified");
            numberOfImages = 10000;
        }
        mov.numberOfImages = numberOfImages;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowNumberOfImages();
    if (img.movListFp && putMovieList()) {
        ShowMessage("List Put Error");
        return;
    }
}
//---------------------------------------------------------------------------
void TSelfSimilarityMovieForm::ShowFileName()
{
    FileNameEdit->Text = img.movListFileName;
}
//---------------------------------------------------------------------------
void TSelfSimilarityMovieForm::ShowNumberOfImages()
{
    char buf[32];

    sprintf(buf, "%.4d", mov.numberOfImages);
    NumberOfImagesEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TSelfSimilarityMovieForm::ShowAll()
{
    ShowFileName();
    ShowNumberOfImages();
}
//---------------------------------------------------------------------------
int TSelfSimilarityMovieForm::SetInitialMovieValue()
{
    if (mov.par0.formula != mov.par1.formula) {
        ShowMessage("Not same fractal formula!");
        FileNameEdit->Enabled       = false;
        NumberOfImagesEdit->Enabled = false;
        ListButton->Enabled         = true;
        return 1;
    }
    mov.zoomOrSim = 1;
    mov.numberOfImages  = 100;
    ShowAll();
    FileNameEdit->Enabled       = true;
    NumberOfImagesEdit->Enabled = true;
    ListButton->Enabled         = false;
    return 0;
}
//---------------------------------------------------------------------------
void TSelfSimilarityMovieForm::ClearMovieValue()
{
    if (img.movListFp)  fclose(img.movListFp);
    img.movListFp = 0;
    img.movListFileName[0] = 0;
    memset(&mov, 0, sizeof(mov));
    FileNameEdit->Enabled       = false;
    NumberOfImagesEdit->Enabled = false;
    FileNameEdit->Text          = "";
    NumberOfImagesEdit->Text    = "";
    StartButton->Enabled        = false;
    TopImageButton->Enabled     = true;
    NextImageButton->Enabled    = true;
    ListButton->Enabled         = true;
    ResetButton->Enabled        = true;
}
//---------------------------------------------------------------------------

