//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "Spiral.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSpiralForm *SpiralForm;
//---------------------------------------------------------------------------
__fastcall TSpiralForm::TSpiralForm(TComponent* Owner)
    : TForm(Owner)
{
    Top  = Screen->Height - Height - 30;
    Left = 8;
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::FormHide(TObject *Sender)
{
    if (img.onDrawing == SpiralShow)  img.threadTerminate = 1;
    img.reverseAnalysis = 0;
    restoreZoomMode();
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::DotRadioButtonClick(TObject *Sender)
{
    img.dotLine = 0;
    if (Visible)  DotRadioButton->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::LineRadioButtonClick(TObject *Sender)
{
    img.dotLine = 1;
    if (Visible)  LineRadioButton->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::ResetButtonClick(TObject *Sender)
{
    img.threadTerminate = 1;
    restoreZoomMode();
    ImageForm->SpiralClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::SaveButtonClick(TObject *Sender)
{
    char dir[MAXPATH];
    TSaveDialog *SaveDialog;

    ImageForm->tempStopRequest();
    SaveDialog = ImageForm->SaveDialog;
    SaveDialog->Filter = "Spiral files (*.spr)|*.SPR";
    SaveDialog->FileName = "";
    strcpy(dir, img.saveAsPath.drive);
    strcat(dir, img.saveAsPath.dir);
    SaveDialog->InitialDir = dir;
    if (SaveDialog->Execute()) {
        saveSpiral();
        savePar(1);
        saveImage(1);
        img.clickIgnore = 1;
    }
    img.threadTempStop = 0;
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::ZoomCheckBoxClick(TObject *Sender)
{
    if (ZoomCheckBox->Checked == true) {
        img.reverseAnalysisZoom = 1;
        restoreZoomMode();
    }
    else {
        img.reverseAnalysisZoom = 0;
        changeToBoxMode();
    }
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::TopRadioButtonClick(TObject *Sender)
{
    img.topNext = 0;
    if (Visible && (demo.onDemo == 0))  TopRadioButton->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::NextRadioButtonClick(TObject *Sender)
{
    img.topNext = 1;
    if (Visible && (demo.onDemo == 0))  NextRadioButton->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSpiralForm::GoButtonClick(TObject *Sender)
{
    spiralGo();
}
//---------------------------------------------------------------------------
void TSpiralForm::ResultMessage(char *message)
{
    ResultLabel->Font->Color = clWindowText;
    ResultLabel->Caption = message;
}
//---------------------------------------------------------------------------
void TSpiralForm::ResultAlarm(char *alarm)
{
    ResultLabel->Font->Color = clRed;
    ResultLabel->Caption = alarm;
}
//---------------------------------------------------------------------------

