//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Common.h"
#include "Image.h"
#include "Control.h"
#include "ImageSize.h"
#include "ZoomInMovie.h"
#include "MovieList.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TZoomInMovieForm *ZoomInMovieForm;
//---------------------------------------------------------------------------
__fastcall TZoomInMovieForm::TZoomInMovieForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::FormHide(TObject *Sender)
{
    StartButton->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::TopImageButtonClick(TObject *Sender)
{
    ImageForm->OpenClick(this);
    if (img.movImageOpened == 0)  return;
    if ((par.imageSize[X] > 1024) || (par.imageSize[Y] > 768)) {
        ShowMessage("Too large. Max is 1024x768.");
        return;
    }
    mov.par0Set = 1;
    mov.par0 = par;
    if (mov.par1Set) {
        if (SetInitialMovieValue()) mov.par0Set = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::LastImageButtonClick(TObject *Sender)
{
    ImageForm->OpenClick(this);
    if (img.movImageOpened == 0)  return;
    mov.par1Set = 1;
    mov.par1 = par;
    if (mov.par0Set) {
        if (SetInitialMovieValue()) mov.par1Set = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::FileNameEditExit(TObject *Sender)
{
    SetFileName();
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::FileNameEditKeyPress(TObject *Sender, char &Key)
{
    if (Key == '\r')  SetFileName();
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::NumberOfImagesEditExit(TObject *Sender)
{
    SetNumberOfImages();
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::NumberOfImagesEditKeyPress(TObject *Sender, char &Key)
{
    if (Key == '\r')  SetNumberOfImages();
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::ZoomInPowerEditExit(TObject *Sender)
{
    SetZoomInPower();
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::ZoomInPowerEditKeyPress(TObject *Sender, char &Key)
{
    if (Key == '\r')  SetZoomInPower();
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::ListButtonClick(TObject *Sender)
{
    char dir[MAXPATH];

    if ((mov.par0Set == 0) || (mov.par1Set == 0)) {
        ImageForm->OpenDialog->Filter = "Movie files (*.zmov)|*.ZMOV";
        ImageForm->OpenDialog->FileName = "";
        strcpy(dir, img.moviePath.drive);
        strcat(dir, img.moviePath.dir);
        ImageForm->OpenDialog->InitialDir = dir;
        if (ImageForm->OpenDialog->Execute()) {
            setMoviePath(ImageForm->OpenDialog->FileName.c_str(), "", EXT_ZMOV);
            if (img.movListFp)  fclose(img.movListFp);
            strcpy(img.movListFileName, img.moviePath.file);
            img.movListFp = fopen(img.moviePath.path, "r+b");
            if (img.movListFp == NULL)  return;
            if (getMovieList()) {
                ShowMessage("List Get Error");
                return;
            }
            TopImageButton->Enabled  = false;
            LastImageButton->Enabled = false;
            FileNameEdit->Enabled        = false;
            NumberOfImagesEdit->Enabled  = false;
            ZoomInPowerEdit->Enabled     = false;
            if (mov.nowSerialNumber < mov.numberOfImages)
                StartButton->Enabled = true;
            ListButton->Enabled  = true;
            mov.onMakingMovie = 0;
            ShowAll();
        }
        else  return;
    }
    MovieListForm->Show();
    MovieListForm->AutoSize = false;
    MovieListForm->AutoSize = true;
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::StartButtonClick(TObject *Sender)
{
    if (mov.onMakingMovie == 0) {
        ImageForm->disableSave();
        ImageForm->disableOutside();
        ImageForm->disableColor();
        ImageForm->disableMakeSelfSimilarityMovie();
        ResetButton->Enabled         = false;
        FileNameEdit->Enabled        = false;
        NumberOfImagesEdit->Enabled  = false;
        ZoomInPowerEdit->Enabled     = false;
        StartButton->Caption = "Stop";
        par = mov.par0;
        ImageSizeForm->ShowAll();
        imageFormInitialize(1);
        startMakeMovie();
    }
    else  img.threadTerminate = 1;
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::ResetButtonClick(TObject *Sender)
{
    ImageForm->ZoomInMovieClick(ImageForm);
}
//---------------------------------------------------------------------------
void __fastcall TZoomInMovieForm::HideButtonClick(TObject *Sender)
{
    Hide();
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::SetFileName()
{
    if (!mov.par0Set || !mov.par1Set)  return;
    if (strcmp(img.movListFileName, FileNameEdit->Text.c_str()) == 0)  return;
    if (StartButton->Enabled && img.movListFp) {
        fclose(img.movListFp);
        remove(img.moviePath.path);
    }
    strcpy(img.movListFileName, FileNameEdit->Text.c_str());
    setMoviePath("", img.movListFileName, EXT_ZMOV);
    if (img.movListFileName[0] == 0) {
        StartButton->Enabled = false;
        ListButton->Enabled  = false;
        return;
    }
    if (openMovieList()) {
        img.movListFileName[0] = 0;
        FileNameEdit->Text = "";
        StartButton->Enabled = false;
        ListButton->Enabled  = false;
        return;
    }
    TopImageButton->Enabled  = false;
    LastImageButton->Enabled = false;
    if (putMovieList()) {
        ShowMessage("List Put Error");
        return;
    }
    StartButton->Enabled = true;
    ListButton->Enabled  = true;
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::SetNumberOfImages()
{
    int numberOfImages;

    if (!mov.par0Set || !mov.par1Set)  return;
    try {
        numberOfImages = StrToInt(NumberOfImagesEdit->Text);
        if (mov.numberOfImages == numberOfImages)  return;
        if (numberOfImages < 2) {
            ShowMessage("Invalid number specified");
            numberOfImages = 2;
        }
        if (numberOfImages > 10000) {
            ShowMessage("Invalid number specified");
            numberOfImages = 10000;
        }
        mov.numberOfImages = numberOfImages;
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    numberOfImagesToZoomInPower();
    ShowNumberOfImages();
    ShowZoomInPower();
    if (img.movListFp && putMovieList()) {
        ShowMessage("List Put Error");
        return;
    }
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::SetZoomInPower()
{
    char buf[32];
    PRECISION zoomInPower, zoom;
    int ret;

    if (!mov.par0Set || !mov.par1Set)  return;
    if (mov.par0.formula == Mandelbrot)
        zoom = mov.par0.pSpan[X] / mov.par1.pSpan[X];
    else
        zoom = mov.par0.c0Span[X] / mov.par1.c0Span[X];
    sprintf(buf, "%.10Lf", mov.zoomInPower);
    if (strcmp(buf, ZoomInPowerEdit->Text.c_str()) == 0)  return;
    try {
        zoomInPower = ZoomInPowerEdit->Text.ToDouble();
        if (zoomInPower <= 0.0) {
            ShowMessage("Invalid number specified");
            ZoomInPowerEdit->Text = buf;
            return;
        }
        if (zoom < 1.0) {
            if (zoomInPower >= 1.0) {
                ShowMessage("Zoom In Power < 1.0");
                ZoomInPowerEdit->Text = buf;
                return;
            }
        }
        else {
            if (zoomInPower <= 1.0) {
                ShowMessage("Zoom In Power > 1.0");
                ZoomInPowerEdit->Text = buf;
                return;
            }
        }
        ret = zoomInPowerToNumberOfImages(zoomInPower);
        switch (ret) {
        case 0:
            mov.zoomInPower = zoomInPower;
            break;
        case 1:
            ShowMessage("Too Few Images");
            ZoomInPowerEdit->Text = buf;
            return;
        case 2:
            ShowMessage("Too Many Images");
            ZoomInPowerEdit->Text = buf;
            return;
        }
    }
    catch(EConvertError *e) {
        ShowMessage("Invalid numeric specified");
    }
    ShowNumberOfImages();
    ShowZoomInPower();
    if (img.movListFp && putMovieList()) {
        ShowMessage("List Put Error");
        return;
    }
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::ShowFileName()
{
    FileNameEdit->Text = img.movListFileName;
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::ShowNumberOfImages()
{
    char buf[32];

    sprintf(buf, "%.4d", mov.numberOfImages);
    NumberOfImagesEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::ShowZoomInPower()
{
    char buf[32];

    sprintf(buf, "%.10Lf", mov.zoomInPower);
    ZoomInPowerEdit->Text = buf;
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::ShowAll()
{
    ShowFileName();
    ShowNumberOfImages();
    ShowZoomInPower();
}
//---------------------------------------------------------------------------
int TZoomInMovieForm::SetInitialMovieValue()
{
    PRECISION zoom;

    if (mov.par0.formula != mov.par1.formula) {
        ShowMessage("Not same fractal formula!");
        FileNameEdit->Enabled        = false;
        NumberOfImagesEdit->Enabled  = false;
        ZoomInPowerEdit->Enabled     = false;
        ListButton->Enabled          = true;
        return 1;
    }
    if (mov.par0.formula == Mandelbrot)
        zoom = mov.par0.pSpan[X] / mov.par1.pSpan[X];
    else
        zoom = mov.par0.c0Span[X] / mov.par1.c0Span[X];
    if ((zoom > 0.8) && (zoom < 1.2)) {
        ShowMessage("Can't zoom!");
        FileNameEdit->Enabled        = false;
        NumberOfImagesEdit->Enabled  = false;
        ZoomInPowerEdit->Enabled     = false;
        ListButton->Enabled          = true;
        return 1;
    }
    mov.zoomOrSim = 0;
    mov.numberOfImages  = 100;
    numberOfImagesToZoomInPower();
    ShowAll();
    FileNameEdit->Enabled        = true;
    NumberOfImagesEdit->Enabled  = true;
    ZoomInPowerEdit->Enabled     = true;
    ListButton->Enabled          = false;
    return 0;
}
//---------------------------------------------------------------------------
void TZoomInMovieForm::ClearMovieValue()
{
    if (img.movListFp)  fclose(img.movListFp);
    img.movListFp = 0;
    img.movListFileName[0] = 0;
    memset(&mov, 0, sizeof(mov));
    FileNameEdit->Enabled        = false;
    NumberOfImagesEdit->Enabled  = false;
    ZoomInPowerEdit->Enabled     = false;
    FileNameEdit->Text           = "";
    NumberOfImagesEdit->Text     = "";
    ZoomInPowerEdit->Text        = "";
    StartButton->Enabled         = false;
    TopImageButton->Enabled      = true;
    LastImageButton->Enabled     = true;
    ListButton->Enabled          = true;
    ResetButton->Enabled         = true;
}
//---------------------------------------------------------------------------

